/*
 * wmdimp
 * Copyright (c) 2004 Daniele Tamino <aslo@wmdimp.cjb.net>.
 * This software covered by the GPL.  See COPYING file for details.
 *
 * gui.c
 *
 * This file contains coordinates of the various gui elements.
 *
 */

#include <config.h>
#include "gui.h"
#include "wmdimp.xpm"
#include "charset.xpm"

char ** wmdimp_pixmap = wmdimp_xpm; /* cause wmdimp_xpm is declared static :-( */
char ** charset_pixmap = charset_xpm;

int char_width = 6;
int char_height = 7;

struct coord btn_pos[] = {
	{22, 49, 11, 11},	/* stop */
	{33, 49, 11, 11},	/* play */
	{0, 0, 0, 0},	/* pause -- not present */
	{5,  49, 17, 11},	/* back */
	{44, 49, 17, 11},	/* next */
	{48, 13, 10,  7},	/* change dir */
	{ 7, 13, 10,  7},	/* random */
	{27, 13, 11,  7},	/* repeat */
	{ 5, 37, 54, 10},	/* song title */
	{ 5, 21, 54, 10},	/* directory/list name */
	{ 4, 32, 56,  4}	/* progress bar */
};

struct coord btn_up[] = {
	{86, 49, 11, 11},	/* stop */
	{97, 49, 11, 11},	/* play */
	{0, 0, 0, 0},	/* pause -- not present */
	{69, 49, 17, 11},	/* back */
	{108,49, 17, 11},	/* next */
	{112,13, 10,  7},	/* change dir */
	{71, 13, 10,  7},	/* random */
	{91, 13, 11,  7},	/* repeat */
	/* titles unchanged */
	{ 5, 16, 54, 10},	/* song title */
	{ 5,  5, 54, 10},	/* directory/list name */
	/* empty progress bar */
	{68, 32, 54,  4}	/* progress bar */
};

struct coord btn_down[] = {
	{150, 49, 11, 11},	/* stop */
	{161, 49, 11, 11},	/* play */
	{0, 0, 0, 0},	/* pause -- not present */
	{133,  49, 17, 11},	/* back */
	{172, 49, 17, 11},	/* next */
	{176, 13, 10,  7},	/* change dir */
	{135, 13, 10,  7},	/* random */
	{155, 13, 11,  7},	/* repeat */
	/* titles unchanged */
	{ 5, 16, 54, 10},	/* song title */
	{ 5,  5, 54, 10},	/* directory/list name */
	/* full progress bar */
	{132, 32, 54,  4}	/* progress bar */
};

struct coord btn_gray[] = {
	{214, 49, 11, 11},	/* stop */
	{225, 49, 11, 11},	/* play */
	{0, 0, 0, 0},	/* pause -- not present */
	{197, 49, 17, 11},	/* back */
	{236, 49, 17, 11},	/* next */
	{240, 13, 10,  7},	/* change dir */
	{199, 13, 10,  7},	/* random */
	{219, 13, 11,  7},	/* repeat */
	/* titles and progress bar unchanged */
	{ 5, 37, 54, 10},	/* song title */
	{ 5, 21, 54, 10},	/* directory/list name */
	{ 4, 32, 56,  4}	/* progress bar */
};

