/*
 * wmdimp
 * Copyright (c) 2004 Daniele Tamino <aslo@wmdimp.cjb.net>.
 * This software covered by the GPL.  See COPYING file for details.
 *
 * mytypes.h
 *
 * Some useful typedef's to improve portability
 * (int8_t, int16_t, int32_t, int64_t, guaranteed to have the correct size)
 *
 */
#ifndef mytypesH
#define mytypesH
#include "config.h"
#if SIZEOF_LONG_LONG != 0
#  define HAVE_LONG_LONG 1
#endif

#ifndef HAVE_INT8_T
#define HAVE_INT8_T  1

/* declare int8_t (to be char of course)  */
#if SIZEOF_CHAR == 1 /* I hope so! */
typedef signed char int8_t;
#else
#undef HAVE_INT8_T
#endif

#endif /* HAVE_INT8_T */

/* declare int16_t to be short (sizeof(short) is >= 2)  */
#ifndef HAVE_INT16_T
#define HAVE_INT16_T 1

#if SIZEOF_SHORT == 2
typedef signed short int int16_t;
#elif SIZEOF_CHAR == 2
/* I think this never happens... hey, this is not java! */
typedef signed char int16_t;
#else
#undef HAVE_INT16_T
#endif

#endif /* HAVE_INT16_T */
/* declare int32_t to be long, int or short (sizeof(long) >= 4) */
#ifndef HAVE_INT32_T
#define HAVE_INT32_T 1

#if SIZEOF_LONG == 4
typedef signed long int int32_t;
#elif SIZEOF_INT == 4
typedef signed int int32_t;
#elif SIZEOF_SHORT == 4
typedef signed short int int32_t; /* I think this never happens */
#else
#undef HAVE_INT32_T
#endif

#endif /* HAVE_INT32_T */

/* declare int64_t to be long, long long, int or short(!) */
#ifndef HAVE_INT64_T
#define HAVE_INT64_T 1

#if SIZEOF_LONG == 8
typedef signed long int int64_t;
#elif SIZEOF_LONG_LONG == 8
typedef long long int64_t;
#elif SIZEOF_INT == 8
typedef signed int int64_t;
#elif SIZEOF_SHORT == 8 /* ??? */
typedef signed short int int64_t;
#else
#undef HAVE_INT64_T
#endif

#endif /* HAVE_INT64_T */

#endif
