/*
 * wmdimp
 * Copyright (c) 2004 Daniele Tamino <aslo@wmdimp.cjb.net>.
 * This software covered by the GPL.  See COPYING file for details.
 *
 * output_funcs.h
 *
 * Many little specialized functions to convert betwees audio formats
 * on the fly when playing.
 *
 */
/* file generated automatically from output_funcs.h.m4: do not edit */

int copy_mono_1_mono_1(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		*(int8_t*)((out)) = (int8_t)((conv)(*(int8_t*)((in)), (channels)));
		in += (1);
		out += (1);
	}
	return n;
}

int copy_stereo_1_stereo_1(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			*(int8_t*)((out)) = (int8_t)((conv)(*(int8_t*)((in)), (channels)));
			*(int8_t*)((out)+1) = (int8_t)((conv)(*(int8_t*)((in)+1), (channels)+1));
		}
		in += (2*(1));
		out += (2*(1));
	}
	return n;
}

int copy_multi_1_multi_1(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int8_t*)((in));
				*(int8_t*)((out)) = (int8_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 1;
				out += 1;
			}
		}
		
		in += (ibps);
		out += (obps);
	}
	return n;
}

int copy_stereo_1_mono_1(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int32_t s1 = *(int8_t*)((in));
			int32_t s2 = *(int8_t*)((in)+1);
			*(int8_t*)((out)) = (int8_t)((conv)((s1 + s2)/2, (channels)));
		}
		
		in += (2*(1));
		out += (1);
	}
	return n;
}

int copy_multi_1_mono_1(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int8_t*)((in)), &(channels)[c]);
				if(c >= ichan) break;
				in += 1;
			}
			*(int8_t*)((out)) = (int8_t)(samp/ichan);
		}
		in += (ibps);
		out += (1);
	}
	return n;
}

int resample_mono_1_mono_1(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (1);
	int inc2 = st->inc2 * (1);
	int i, j;
	nin *= (1);
	nout *= (1);
	for(i = 0, j = 0; i < nout && j < nin; i += (1)) {
		*(int8_t*)((out + i)) = (int8_t)((conv)(*(int8_t*)((in + j)), (channels)));
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (1);
	return i / (1);
}

int resample_stereo_1_stereo_1(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(1));
	int inc2 = st->inc2 * (2*(1));
	int i, j;
	nin *= (2*(1));
	nout *= (2*(1));
	for(i = 0, j = 0; i < nout && j < nin; i += (2*(1))) {
		{
			*(int8_t*)((out + i)) = (int8_t)((conv)(*(int8_t*)((in + j)), (channels)));
			*(int8_t*)((out + i)+1) = (int8_t)((conv)(*(int8_t*)((in + j)+1), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(1));
	return i / (2*(1));
}

int resample_multi_1_multi_1(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (obps);
	for(i = 0, j = 0; i < nout && j < nin; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int8_t*)((in + j));
				*(int8_t*)((out + i)) = (int8_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 1;
				out += 1;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (obps);
}

int resample_stereo_1_mono_1(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(1));
	int inc2 = st->inc2 * (2*(1));
	int i, j;
	nin *= (2*(1));
	nout *= (1);
	for(i = 0, j = 0; i < nout && j < nin; i += (1)) {
		{
			int32_t s1 = *(int8_t*)((in + j));
			int32_t s2 = *(int8_t*)((in + j)+1);
			*(int8_t*)((out + i)) = (int8_t)((conv)((s1 + s2)/2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(1));
	return i / (1);
}

int resample_multi_1_mono_1(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (1);
	for(i = 0, j = 0; i < nout && j < nin; i += (1)) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int8_t*)((in + j)), &(channels)[c]);
				if(c >= ichan) break;
				in += 1;
			}
			*(int8_t*)((out + i)) = (int8_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (1);
}

int copy_mono_1_mono_2(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		*(int16_t*)((out)) = (int16_t)((conv)(*(int8_t*)((in)), (channels)));
		in += (1);
		out += (2);
	}
	return n;
}

int copy_stereo_1_stereo_2(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			*(int16_t*)((out)) = (int16_t)((conv)(*(int8_t*)((in)), (channels)));
			*(int16_t*)((out)+2) = (int16_t)((conv)(*(int8_t*)((in)+1), (channels)+1));
		}
		in += (2*(1));
		out += (2*(2));
	}
	return n;
}

int copy_multi_1_multi_2(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int8_t*)((in));
				*(int16_t*)((out)) = (int16_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 1;
				out += 2;
			}
		}
		
		in += (ibps);
		out += (obps);
	}
	return n;
}

int copy_stereo_1_mono_2(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int32_t s1 = *(int8_t*)((in));
			int32_t s2 = *(int8_t*)((in)+1);
			*(int16_t*)((out)) = (int16_t)((conv)((s1 + s2)/2, (channels)));
		}
		
		in += (2*(1));
		out += (2);
	}
	return n;
}

int copy_multi_1_mono_2(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int8_t*)((in)), &(channels)[c]);
				if(c >= ichan) break;
				in += 1;
			}
			*(int16_t*)((out)) = (int16_t)(samp/ichan);
		}
		in += (ibps);
		out += (2);
	}
	return n;
}

int resample_mono_1_mono_2(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (1);
	int inc2 = st->inc2 * (1);
	int i, j;
	nin *= (1);
	nout *= (2);
	for(i = 0, j = 0; i < nout && j < nin; i += (2)) {
		*(int16_t*)((out + i)) = (int16_t)((conv)(*(int8_t*)((in + j)), (channels)));
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (1);
	return i / (2);
}

int resample_stereo_1_stereo_2(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(1));
	int inc2 = st->inc2 * (2*(1));
	int i, j;
	nin *= (2*(1));
	nout *= (2*(2));
	for(i = 0, j = 0; i < nout && j < nin; i += (2*(2))) {
		{
			*(int16_t*)((out + i)) = (int16_t)((conv)(*(int8_t*)((in + j)), (channels)));
			*(int16_t*)((out + i)+2) = (int16_t)((conv)(*(int8_t*)((in + j)+1), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(1));
	return i / (2*(2));
}

int resample_multi_1_multi_2(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (obps);
	for(i = 0, j = 0; i < nout && j < nin; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int8_t*)((in + j));
				*(int16_t*)((out + i)) = (int16_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 1;
				out += 2;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (obps);
}

int resample_stereo_1_mono_2(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(1));
	int inc2 = st->inc2 * (2*(1));
	int i, j;
	nin *= (2*(1));
	nout *= (2);
	for(i = 0, j = 0; i < nout && j < nin; i += (2)) {
		{
			int32_t s1 = *(int8_t*)((in + j));
			int32_t s2 = *(int8_t*)((in + j)+1);
			*(int16_t*)((out + i)) = (int16_t)((conv)((s1 + s2)/2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(1));
	return i / (2);
}

int resample_multi_1_mono_2(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (2);
	for(i = 0, j = 0; i < nout && j < nin; i += (2)) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int8_t*)((in + j)), &(channels)[c]);
				if(c >= ichan) break;
				in += 1;
			}
			*(int16_t*)((out + i)) = (int16_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (2);
}

int copy_mono_1_mono_4(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		*(int32_t*)((out)) = (int32_t)((conv)(*(int8_t*)((in)), (channels)));
		in += (1);
		out += (4);
	}
	return n;
}

int copy_stereo_1_stereo_4(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			*(int32_t*)((out)) = (int32_t)((conv)(*(int8_t*)((in)), (channels)));
			*(int32_t*)((out)+4) = (int32_t)((conv)(*(int8_t*)((in)+1), (channels)+1));
		}
		in += (2*(1));
		out += (2*(4));
	}
	return n;
}

int copy_multi_1_multi_4(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int8_t*)((in));
				*(int32_t*)((out)) = (int32_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 1;
				out += 4;
			}
		}
		
		in += (ibps);
		out += (obps);
	}
	return n;
}

int copy_stereo_1_mono_4(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int32_t s1 = *(int8_t*)((in));
			int32_t s2 = *(int8_t*)((in)+1);
			*(int32_t*)((out)) = (int32_t)((conv)((s1 + s2)/2, (channels)));
		}
		
		in += (2*(1));
		out += (4);
	}
	return n;
}

int copy_multi_1_mono_4(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int c = 0;
			int64_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int8_t*)((in)), &(channels)[c]);
				if(c >= ichan) break;
				in += 1;
			}
			*(int32_t*)((out)) = (int32_t)(samp/ichan);
		}
		in += (ibps);
		out += (4);
	}
	return n;
}

int resample_mono_1_mono_4(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (1);
	int inc2 = st->inc2 * (1);
	int i, j;
	nin *= (1);
	nout *= (4);
	for(i = 0, j = 0; i < nout && j < nin; i += (4)) {
		*(int32_t*)((out + i)) = (int32_t)((conv)(*(int8_t*)((in + j)), (channels)));
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (1);
	return i / (4);
}

int resample_stereo_1_stereo_4(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(1));
	int inc2 = st->inc2 * (2*(1));
	int i, j;
	nin *= (2*(1));
	nout *= (2*(4));
	for(i = 0, j = 0; i < nout && j < nin; i += (2*(4))) {
		{
			*(int32_t*)((out + i)) = (int32_t)((conv)(*(int8_t*)((in + j)), (channels)));
			*(int32_t*)((out + i)+4) = (int32_t)((conv)(*(int8_t*)((in + j)+1), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(1));
	return i / (2*(4));
}

int resample_multi_1_multi_4(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (obps);
	for(i = 0, j = 0; i < nout && j < nin; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int8_t*)((in + j));
				*(int32_t*)((out + i)) = (int32_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 1;
				out += 4;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (obps);
}

int resample_stereo_1_mono_4(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(1));
	int inc2 = st->inc2 * (2*(1));
	int i, j;
	nin *= (2*(1));
	nout *= (4);
	for(i = 0, j = 0; i < nout && j < nin; i += (4)) {
		{
			int32_t s1 = *(int8_t*)((in + j));
			int32_t s2 = *(int8_t*)((in + j)+1);
			*(int32_t*)((out + i)) = (int32_t)((conv)((s1 + s2)/2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(1));
	return i / (4);
}

int resample_multi_1_mono_4(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (4);
	for(i = 0, j = 0; i < nout && j < nin; i += (4)) {
		{
			int c = 0;
			int64_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int8_t*)((in + j)), &(channels)[c]);
				if(c >= ichan) break;
				in += 1;
			}
			*(int32_t*)((out + i)) = (int32_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (4);
}

int copy_mono_2_mono_1(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		*(int8_t*)((out)) = (int8_t)((conv)(*(int16_t*)((in)), (channels)));
		in += (2);
		out += (1);
	}
	return n;
}

int copy_stereo_2_stereo_1(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			*(int8_t*)((out)) = (int8_t)((conv)(*(int16_t*)((in)), (channels)));
			*(int8_t*)((out)+1) = (int8_t)((conv)(*(int16_t*)((in)+2), (channels)+1));
		}
		in += (2*(2));
		out += (2*(1));
	}
	return n;
}

int copy_multi_2_multi_1(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int16_t*)((in));
				*(int8_t*)((out)) = (int8_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 2;
				out += 1;
			}
		}
		
		in += (ibps);
		out += (obps);
	}
	return n;
}

int copy_stereo_2_mono_1(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int32_t s1 = *(int16_t*)((in));
			int32_t s2 = *(int16_t*)((in)+2);
			*(int8_t*)((out)) = (int8_t)((conv)((s1 + s2)/2, (channels)));
		}
		
		in += (2*(2));
		out += (1);
	}
	return n;
}

int copy_multi_2_mono_1(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int16_t*)((in)), &(channels)[c]);
				if(c >= ichan) break;
				in += 2;
			}
			*(int8_t*)((out)) = (int8_t)(samp/ichan);
		}
		in += (ibps);
		out += (1);
	}
	return n;
}

int resample_mono_2_mono_1(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2);
	int inc2 = st->inc2 * (2);
	int i, j;
	nin *= (2);
	nout *= (1);
	for(i = 0, j = 0; i < nout && j < nin; i += (1)) {
		*(int8_t*)((out + i)) = (int8_t)((conv)(*(int16_t*)((in + j)), (channels)));
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2);
	return i / (1);
}

int resample_stereo_2_stereo_1(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(2));
	int inc2 = st->inc2 * (2*(2));
	int i, j;
	nin *= (2*(2));
	nout *= (2*(1));
	for(i = 0, j = 0; i < nout && j < nin; i += (2*(1))) {
		{
			*(int8_t*)((out + i)) = (int8_t)((conv)(*(int16_t*)((in + j)), (channels)));
			*(int8_t*)((out + i)+1) = (int8_t)((conv)(*(int16_t*)((in + j)+2), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(2));
	return i / (2*(1));
}

int resample_multi_2_multi_1(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (obps);
	for(i = 0, j = 0; i < nout && j < nin; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int16_t*)((in + j));
				*(int8_t*)((out + i)) = (int8_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 2;
				out += 1;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (obps);
}

int resample_stereo_2_mono_1(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(2));
	int inc2 = st->inc2 * (2*(2));
	int i, j;
	nin *= (2*(2));
	nout *= (1);
	for(i = 0, j = 0; i < nout && j < nin; i += (1)) {
		{
			int32_t s1 = *(int16_t*)((in + j));
			int32_t s2 = *(int16_t*)((in + j)+2);
			*(int8_t*)((out + i)) = (int8_t)((conv)((s1 + s2)/2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(2));
	return i / (1);
}

int resample_multi_2_mono_1(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (1);
	for(i = 0, j = 0; i < nout && j < nin; i += (1)) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int16_t*)((in + j)), &(channels)[c]);
				if(c >= ichan) break;
				in += 2;
			}
			*(int8_t*)((out + i)) = (int8_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (1);
}

int copy_mono_2_mono_2(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		*(int16_t*)((out)) = (int16_t)((conv)(*(int16_t*)((in)), (channels)));
		in += (2);
		out += (2);
	}
	return n;
}

int copy_stereo_2_stereo_2(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			*(int16_t*)((out)) = (int16_t)((conv)(*(int16_t*)((in)), (channels)));
			*(int16_t*)((out)+2) = (int16_t)((conv)(*(int16_t*)((in)+2), (channels)+1));
		}
		in += (2*(2));
		out += (2*(2));
	}
	return n;
}

int copy_multi_2_multi_2(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int16_t*)((in));
				*(int16_t*)((out)) = (int16_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 2;
				out += 2;
			}
		}
		
		in += (ibps);
		out += (obps);
	}
	return n;
}

int copy_stereo_2_mono_2(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int32_t s1 = *(int16_t*)((in));
			int32_t s2 = *(int16_t*)((in)+2);
			*(int16_t*)((out)) = (int16_t)((conv)((s1 + s2)/2, (channels)));
		}
		
		in += (2*(2));
		out += (2);
	}
	return n;
}

int copy_multi_2_mono_2(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int16_t*)((in)), &(channels)[c]);
				if(c >= ichan) break;
				in += 2;
			}
			*(int16_t*)((out)) = (int16_t)(samp/ichan);
		}
		in += (ibps);
		out += (2);
	}
	return n;
}

int resample_mono_2_mono_2(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2);
	int inc2 = st->inc2 * (2);
	int i, j;
	nin *= (2);
	nout *= (2);
	for(i = 0, j = 0; i < nout && j < nin; i += (2)) {
		*(int16_t*)((out + i)) = (int16_t)((conv)(*(int16_t*)((in + j)), (channels)));
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2);
	return i / (2);
}

int resample_stereo_2_stereo_2(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(2));
	int inc2 = st->inc2 * (2*(2));
	int i, j;
	nin *= (2*(2));
	nout *= (2*(2));
	for(i = 0, j = 0; i < nout && j < nin; i += (2*(2))) {
		{
			*(int16_t*)((out + i)) = (int16_t)((conv)(*(int16_t*)((in + j)), (channels)));
			*(int16_t*)((out + i)+2) = (int16_t)((conv)(*(int16_t*)((in + j)+2), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(2));
	return i / (2*(2));
}

int resample_multi_2_multi_2(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (obps);
	for(i = 0, j = 0; i < nout && j < nin; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int16_t*)((in + j));
				*(int16_t*)((out + i)) = (int16_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 2;
				out += 2;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (obps);
}

int resample_stereo_2_mono_2(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(2));
	int inc2 = st->inc2 * (2*(2));
	int i, j;
	nin *= (2*(2));
	nout *= (2);
	for(i = 0, j = 0; i < nout && j < nin; i += (2)) {
		{
			int32_t s1 = *(int16_t*)((in + j));
			int32_t s2 = *(int16_t*)((in + j)+2);
			*(int16_t*)((out + i)) = (int16_t)((conv)((s1 + s2)/2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(2));
	return i / (2);
}

int resample_multi_2_mono_2(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (2);
	for(i = 0, j = 0; i < nout && j < nin; i += (2)) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int16_t*)((in + j)), &(channels)[c]);
				if(c >= ichan) break;
				in += 2;
			}
			*(int16_t*)((out + i)) = (int16_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (2);
}

int copy_mono_2_mono_4(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		*(int32_t*)((out)) = (int32_t)((conv)(*(int16_t*)((in)), (channels)));
		in += (2);
		out += (4);
	}
	return n;
}

int copy_stereo_2_stereo_4(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			*(int32_t*)((out)) = (int32_t)((conv)(*(int16_t*)((in)), (channels)));
			*(int32_t*)((out)+4) = (int32_t)((conv)(*(int16_t*)((in)+2), (channels)+1));
		}
		in += (2*(2));
		out += (2*(4));
	}
	return n;
}

int copy_multi_2_multi_4(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int16_t*)((in));
				*(int32_t*)((out)) = (int32_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 2;
				out += 4;
			}
		}
		
		in += (ibps);
		out += (obps);
	}
	return n;
}

int copy_stereo_2_mono_4(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int32_t s1 = *(int16_t*)((in));
			int32_t s2 = *(int16_t*)((in)+2);
			*(int32_t*)((out)) = (int32_t)((conv)((s1 + s2)/2, (channels)));
		}
		
		in += (2*(2));
		out += (4);
	}
	return n;
}

int copy_multi_2_mono_4(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int c = 0;
			int64_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int16_t*)((in)), &(channels)[c]);
				if(c >= ichan) break;
				in += 2;
			}
			*(int32_t*)((out)) = (int32_t)(samp/ichan);
		}
		in += (ibps);
		out += (4);
	}
	return n;
}

int resample_mono_2_mono_4(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2);
	int inc2 = st->inc2 * (2);
	int i, j;
	nin *= (2);
	nout *= (4);
	for(i = 0, j = 0; i < nout && j < nin; i += (4)) {
		*(int32_t*)((out + i)) = (int32_t)((conv)(*(int16_t*)((in + j)), (channels)));
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2);
	return i / (4);
}

int resample_stereo_2_stereo_4(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(2));
	int inc2 = st->inc2 * (2*(2));
	int i, j;
	nin *= (2*(2));
	nout *= (2*(4));
	for(i = 0, j = 0; i < nout && j < nin; i += (2*(4))) {
		{
			*(int32_t*)((out + i)) = (int32_t)((conv)(*(int16_t*)((in + j)), (channels)));
			*(int32_t*)((out + i)+4) = (int32_t)((conv)(*(int16_t*)((in + j)+2), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(2));
	return i / (2*(4));
}

int resample_multi_2_multi_4(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (obps);
	for(i = 0, j = 0; i < nout && j < nin; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int16_t*)((in + j));
				*(int32_t*)((out + i)) = (int32_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 2;
				out += 4;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (obps);
}

int resample_stereo_2_mono_4(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(2));
	int inc2 = st->inc2 * (2*(2));
	int i, j;
	nin *= (2*(2));
	nout *= (4);
	for(i = 0, j = 0; i < nout && j < nin; i += (4)) {
		{
			int32_t s1 = *(int16_t*)((in + j));
			int32_t s2 = *(int16_t*)((in + j)+2);
			*(int32_t*)((out + i)) = (int32_t)((conv)((s1 + s2)/2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(2));
	return i / (4);
}

int resample_multi_2_mono_4(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (4);
	for(i = 0, j = 0; i < nout && j < nin; i += (4)) {
		{
			int c = 0;
			int64_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int16_t*)((in + j)), &(channels)[c]);
				if(c >= ichan) break;
				in += 2;
			}
			*(int32_t*)((out + i)) = (int32_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (4);
}

int copy_mono_4_mono_1(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		*(int8_t*)((out)) = (int8_t)((conv)(*(int32_t*)((in)), (channels)));
		in += (4);
		out += (1);
	}
	return n;
}

int copy_stereo_4_stereo_1(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			*(int8_t*)((out)) = (int8_t)((conv)(*(int32_t*)((in)), (channels)));
			*(int8_t*)((out)+1) = (int8_t)((conv)(*(int32_t*)((in)+4), (channels)+1));
		}
		in += (2*(4));
		out += (2*(1));
	}
	return n;
}

int copy_multi_4_multi_1(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int32_t*)((in));
				*(int8_t*)((out)) = (int8_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 4;
				out += 1;
			}
		}
		
		in += (ibps);
		out += (obps);
	}
	return n;
}

int copy_stereo_4_mono_1(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int32_t s1 = *(int32_t*)((in)) / 2;
			int32_t s2 = *(int32_t*)((in)+4) / 2;
			*(int8_t*)((out)) = (int8_t)((conv)(s1 + s2, (channels)));
		}
		
		in += (2*(4));
		out += (1);
	}
	return n;
}

int copy_multi_4_mono_1(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int32_t*)((in)), &(channels)[c]);
				if(c >= ichan) break;
				in += 4;
			}
			*(int8_t*)((out)) = (int8_t)(samp/ichan);
		}
		in += (ibps);
		out += (1);
	}
	return n;
}

int resample_mono_4_mono_1(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (4);
	int inc2 = st->inc2 * (4);
	int i, j;
	nin *= (4);
	nout *= (1);
	for(i = 0, j = 0; i < nout && j < nin; i += (1)) {
		*(int8_t*)((out + i)) = (int8_t)((conv)(*(int32_t*)((in + j)), (channels)));
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (4);
	return i / (1);
}

int resample_stereo_4_stereo_1(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(4));
	int inc2 = st->inc2 * (2*(4));
	int i, j;
	nin *= (2*(4));
	nout *= (2*(1));
	for(i = 0, j = 0; i < nout && j < nin; i += (2*(1))) {
		{
			*(int8_t*)((out + i)) = (int8_t)((conv)(*(int32_t*)((in + j)), (channels)));
			*(int8_t*)((out + i)+1) = (int8_t)((conv)(*(int32_t*)((in + j)+4), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(4));
	return i / (2*(1));
}

int resample_multi_4_multi_1(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (obps);
	for(i = 0, j = 0; i < nout && j < nin; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int32_t*)((in + j));
				*(int8_t*)((out + i)) = (int8_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 4;
				out += 1;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (obps);
}

int resample_stereo_4_mono_1(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(4));
	int inc2 = st->inc2 * (2*(4));
	int i, j;
	nin *= (2*(4));
	nout *= (1);
	for(i = 0, j = 0; i < nout && j < nin; i += (1)) {
		{
			int32_t s1 = *(int32_t*)((in + j)) / 2;
			int32_t s2 = *(int32_t*)((in + j)+4) / 2;
			*(int8_t*)((out + i)) = (int8_t)((conv)(s1 + s2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(4));
	return i / (1);
}

int resample_multi_4_mono_1(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (1);
	for(i = 0, j = 0; i < nout && j < nin; i += (1)) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int32_t*)((in + j)), &(channels)[c]);
				if(c >= ichan) break;
				in += 4;
			}
			*(int8_t*)((out + i)) = (int8_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (1);
}

int copy_mono_4_mono_2(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		*(int16_t*)((out)) = (int16_t)((conv)(*(int32_t*)((in)), (channels)));
		in += (4);
		out += (2);
	}
	return n;
}

int copy_stereo_4_stereo_2(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			*(int16_t*)((out)) = (int16_t)((conv)(*(int32_t*)((in)), (channels)));
			*(int16_t*)((out)+2) = (int16_t)((conv)(*(int32_t*)((in)+4), (channels)+1));
		}
		in += (2*(4));
		out += (2*(2));
	}
	return n;
}

int copy_multi_4_multi_2(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int32_t*)((in));
				*(int16_t*)((out)) = (int16_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 4;
				out += 2;
			}
		}
		
		in += (ibps);
		out += (obps);
	}
	return n;
}

int copy_stereo_4_mono_2(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int32_t s1 = *(int32_t*)((in)) / 2;
			int32_t s2 = *(int32_t*)((in)+4) / 2;
			*(int16_t*)((out)) = (int16_t)((conv)(s1 + s2, (channels)));
		}
		
		in += (2*(4));
		out += (2);
	}
	return n;
}

int copy_multi_4_mono_2(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int32_t*)((in)), &(channels)[c]);
				if(c >= ichan) break;
				in += 4;
			}
			*(int16_t*)((out)) = (int16_t)(samp/ichan);
		}
		in += (ibps);
		out += (2);
	}
	return n;
}

int resample_mono_4_mono_2(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (4);
	int inc2 = st->inc2 * (4);
	int i, j;
	nin *= (4);
	nout *= (2);
	for(i = 0, j = 0; i < nout && j < nin; i += (2)) {
		*(int16_t*)((out + i)) = (int16_t)((conv)(*(int32_t*)((in + j)), (channels)));
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (4);
	return i / (2);
}

int resample_stereo_4_stereo_2(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(4));
	int inc2 = st->inc2 * (2*(4));
	int i, j;
	nin *= (2*(4));
	nout *= (2*(2));
	for(i = 0, j = 0; i < nout && j < nin; i += (2*(2))) {
		{
			*(int16_t*)((out + i)) = (int16_t)((conv)(*(int32_t*)((in + j)), (channels)));
			*(int16_t*)((out + i)+2) = (int16_t)((conv)(*(int32_t*)((in + j)+4), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(4));
	return i / (2*(2));
}

int resample_multi_4_multi_2(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (obps);
	for(i = 0, j = 0; i < nout && j < nin; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int32_t*)((in + j));
				*(int16_t*)((out + i)) = (int16_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 4;
				out += 2;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (obps);
}

int resample_stereo_4_mono_2(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(4));
	int inc2 = st->inc2 * (2*(4));
	int i, j;
	nin *= (2*(4));
	nout *= (2);
	for(i = 0, j = 0; i < nout && j < nin; i += (2)) {
		{
			int32_t s1 = *(int32_t*)((in + j)) / 2;
			int32_t s2 = *(int32_t*)((in + j)+4) / 2;
			*(int16_t*)((out + i)) = (int16_t)((conv)(s1 + s2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(4));
	return i / (2);
}

int resample_multi_4_mono_2(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (2);
	for(i = 0, j = 0; i < nout && j < nin; i += (2)) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int32_t*)((in + j)), &(channels)[c]);
				if(c >= ichan) break;
				in += 4;
			}
			*(int16_t*)((out + i)) = (int16_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (2);
}

int copy_mono_4_mono_4(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		*(int32_t*)((out)) = (int32_t)((conv)(*(int32_t*)((in)), (channels)));
		in += (4);
		out += (4);
	}
	return n;
}

int copy_stereo_4_stereo_4(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			*(int32_t*)((out)) = (int32_t)((conv)(*(int32_t*)((in)), (channels)));
			*(int32_t*)((out)+4) = (int32_t)((conv)(*(int32_t*)((in)+4), (channels)+1));
		}
		in += (2*(4));
		out += (2*(4));
	}
	return n;
}

int copy_multi_4_multi_4(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int32_t*)((in));
				*(int32_t*)((out)) = (int32_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 4;
				out += 4;
			}
		}
		
		in += (ibps);
		out += (obps);
	}
	return n;
}

int copy_stereo_4_mono_4(char* in, char* out, long n)
{
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int32_t s1 = *(int32_t*)((in)) / 2;
			int32_t s2 = *(int32_t*)((in)+4) / 2;
			*(int32_t*)((out)) = (int32_t)((conv)(s1 + s2, (channels)));
		}
		
		in += (2*(4));
		out += (4);
	}
	return n;
}

int copy_multi_4_mono_4(char* in, char* out, long n)
{
int ibps = in_bps; /* load into register (or cache)*/
	long i;
	convert_channel_func conv = convert_chan;
	for(i = 0; i < n; i++) {
		{
			int c = 0;
			int64_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int32_t*)((in)), &(channels)[c]);
				if(c >= ichan) break;
				in += 4;
			}
			*(int32_t*)((out)) = (int32_t)(samp/ichan);
		}
		in += (ibps);
		out += (4);
	}
	return n;
}

int resample_mono_4_mono_4(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (4);
	int inc2 = st->inc2 * (4);
	int i, j;
	nin *= (4);
	nout *= (4);
	for(i = 0, j = 0; i < nout && j < nin; i += (4)) {
		*(int32_t*)((out + i)) = (int32_t)((conv)(*(int32_t*)((in + j)), (channels)));
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (4);
	return i / (4);
}

int resample_stereo_4_stereo_4(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(4));
	int inc2 = st->inc2 * (2*(4));
	int i, j;
	nin *= (2*(4));
	nout *= (2*(4));
	for(i = 0, j = 0; i < nout && j < nin; i += (2*(4))) {
		{
			*(int32_t*)((out + i)) = (int32_t)((conv)(*(int32_t*)((in + j)), (channels)));
			*(int32_t*)((out + i)+4) = (int32_t)((conv)(*(int32_t*)((in + j)+4), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(4));
	return i / (2*(4));
}

int resample_multi_4_multi_4(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (obps);
	for(i = 0, j = 0; i < nout && j < nin; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int32_t*)((in + j));
				*(int32_t*)((out + i)) = (int32_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				if(++ic >= ichan) ichan = 0;
				in += 4;
				out += 4;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (obps);
}

int resample_stereo_4_mono_4(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (2*(4));
	int inc2 = st->inc2 * (2*(4));
	int i, j;
	nin *= (2*(4));
	nout *= (4);
	for(i = 0, j = 0; i < nout && j < nin; i += (4)) {
		{
			int32_t s1 = *(int32_t*)((in + j)) / 2;
			int32_t s2 = *(int32_t*)((in + j)+4) / 2;
			*(int32_t*)((out + i)) = (int32_t)((conv)(s1 + s2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (2*(4));
	return i / (4);
}

int resample_multi_4_mono_4(char* in, char* out,
		  long nin, long nout, long* ni, resample_state* st)
{
int ibps = in_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * (ibps);
	int inc2 = st->inc2 * (ibps);
	int i, j;
	nin *= (ibps);
	nout *= (4);
	for(i = 0, j = 0; i < nout && j < nin; i += (4)) {
		{
			int c = 0;
			int64_t samp = 0;
			int ichan = in_fmt.chan;
			while(1) {
				samp += (conv)(*(int32_t*)((in + j)), &(channels)[c]);
				if(c >= ichan) break;
				in += 4;
			}
			*(int32_t*)((out + i)) = (int32_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = j / (ibps);
	return i / (4);
}



int copy_sep_stereo_1_stereo_1(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 1;
	for(i = (long) in; i < end; i+= 1) {
		{
			*(int8_t*)((out)) = (int8_t)((conv)(*(int8_t*)(p+(i)), (channels)));
			*(int8_t*)((out)+1) = (int8_t)((conv)(*(int8_t*)(q+(i)), (channels)+1));
		}
		out += (2*(1));
	}
	return n;
}

int copy_sep_multi_1_multi_1(char* in, char* out, long n)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 1;
	for(i = (long) in; i < end; i+= 1) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int8_t*)(input_data[ic] + (i));
				*(int8_t*)((out)) = (int8_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 1;
			}
		}
		
		out += (obps);
	}
	return n;
}

int copy_sep_stereo_1_mono_1(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 1;
	for(i = (long) in; i < end; i+= 1) {
		{
			int32_t s1 = *(int8_t*)(p+(i));
			int32_t s2 = *(int8_t*)(q+(i));
			*(int8_t*)((out)) = (int8_t)((conv)((s1 + s2) / 2, (channels)));
		}
		
		out += (1);
	}
	return n;
}

int copy_sep_multi_1_mono_1(char* in, char* out, long n)
{

	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 1;
	for(i = (long) in; i < end; i+= 1) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int8_t*)(input_data[c]+(i)), &(channels)[c]);
			} while(c < ichan);
			*(int8_t*)((out)) = (int8_t)(samp/ichan);
		}
		out += (1);
	}
	return n;
}


int resample_sep_stereo_1_stereo_1(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 1;
	int inc2 = st->inc2 * 1;
	long i, j;
	long jend = (long) in + nin * 1;
	long iend = nout * (2*(1));
	for(i = 0, j = (long) in; i < iend && j < jend; i += (2*(1))) {
		{
			*(int8_t*)(((out + i))) = (int8_t)((conv)(*(int8_t*)(p+(j)), (channels)));
			*(int8_t*)(((out + i))+1) = (int8_t)((conv)(*(int8_t*)(q+(j)), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 1;
	return i / (2*(1));
}

int resample_sep_multi_1_multi_1(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 1;
	int inc2 = st->inc2 * 1;
	long i, j;
	long jend = (long) in + nin * 1;
	long iend = nout * (obps);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int8_t*)(input_data[ic] + (j));
				*(int8_t*)(((out + i))) = (int8_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 1;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 1;
	return i / (obps);
}

int resample_sep_stereo_1_mono_1(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 1;
	int inc2 = st->inc2 * 1;
	long i, j;
	long jend = (long) in + nin * 1;
	long iend = nout * (1);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (1)) {
		{
			int32_t s1 = *(int8_t*)(p+(j));
			int32_t s2 = *(int8_t*)(q+(j));
			*(int8_t*)(((out + i))) = (int8_t)((conv)((s1 + s2) / 2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 1;
	return i / (1);
}

int resample_sep_multi_1_mono_1(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 1;
	int inc2 = st->inc2 * 1;
	long i, j;
	long jend = (long) in + nin * 1;
	long iend = nout * (1);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (1)) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int8_t*)(input_data[c]+(j)), &(channels)[c]);
			} while(c < ichan);
			*(int8_t*)(((out + i))) = (int8_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 1;
	return i / (1);
}


int copy_sep_stereo_1_stereo_2(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 1;
	for(i = (long) in; i < end; i+= 1) {
		{
			*(int16_t*)((out)) = (int16_t)((conv)(*(int8_t*)(p+(i)), (channels)));
			*(int16_t*)((out)+2) = (int16_t)((conv)(*(int8_t*)(q+(i)), (channels)+1));
		}
		out += (2*(2));
	}
	return n;
}

int copy_sep_multi_1_multi_2(char* in, char* out, long n)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 1;
	for(i = (long) in; i < end; i+= 1) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int8_t*)(input_data[ic] + (i));
				*(int16_t*)((out)) = (int16_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 2;
			}
		}
		
		out += (obps);
	}
	return n;
}

int copy_sep_stereo_1_mono_2(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 1;
	for(i = (long) in; i < end; i+= 1) {
		{
			int32_t s1 = *(int8_t*)(p+(i));
			int32_t s2 = *(int8_t*)(q+(i));
			*(int16_t*)((out)) = (int16_t)((conv)((s1 + s2) / 2, (channels)));
		}
		
		out += (2);
	}
	return n;
}

int copy_sep_multi_1_mono_2(char* in, char* out, long n)
{

	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 1;
	for(i = (long) in; i < end; i+= 1) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int8_t*)(input_data[c]+(i)), &(channels)[c]);
			} while(c < ichan);
			*(int16_t*)((out)) = (int16_t)(samp/ichan);
		}
		out += (2);
	}
	return n;
}


int resample_sep_stereo_1_stereo_2(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 1;
	int inc2 = st->inc2 * 1;
	long i, j;
	long jend = (long) in + nin * 1;
	long iend = nout * (2*(2));
	for(i = 0, j = (long) in; i < iend && j < jend; i += (2*(2))) {
		{
			*(int16_t*)(((out + i))) = (int16_t)((conv)(*(int8_t*)(p+(j)), (channels)));
			*(int16_t*)(((out + i))+2) = (int16_t)((conv)(*(int8_t*)(q+(j)), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 1;
	return i / (2*(2));
}

int resample_sep_multi_1_multi_2(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 1;
	int inc2 = st->inc2 * 1;
	long i, j;
	long jend = (long) in + nin * 1;
	long iend = nout * (obps);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int8_t*)(input_data[ic] + (j));
				*(int16_t*)(((out + i))) = (int16_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 2;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 1;
	return i / (obps);
}

int resample_sep_stereo_1_mono_2(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 1;
	int inc2 = st->inc2 * 1;
	long i, j;
	long jend = (long) in + nin * 1;
	long iend = nout * (2);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (2)) {
		{
			int32_t s1 = *(int8_t*)(p+(j));
			int32_t s2 = *(int8_t*)(q+(j));
			*(int16_t*)(((out + i))) = (int16_t)((conv)((s1 + s2) / 2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 1;
	return i / (2);
}

int resample_sep_multi_1_mono_2(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 1;
	int inc2 = st->inc2 * 1;
	long i, j;
	long jend = (long) in + nin * 1;
	long iend = nout * (2);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (2)) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int8_t*)(input_data[c]+(j)), &(channels)[c]);
			} while(c < ichan);
			*(int16_t*)(((out + i))) = (int16_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 1;
	return i / (2);
}


int copy_sep_stereo_1_stereo_4(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 1;
	for(i = (long) in; i < end; i+= 1) {
		{
			*(int32_t*)((out)) = (int32_t)((conv)(*(int8_t*)(p+(i)), (channels)));
			*(int32_t*)((out)+4) = (int32_t)((conv)(*(int8_t*)(q+(i)), (channels)+1));
		}
		out += (2*(4));
	}
	return n;
}

int copy_sep_multi_1_multi_4(char* in, char* out, long n)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 1;
	for(i = (long) in; i < end; i+= 1) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int8_t*)(input_data[ic] + (i));
				*(int32_t*)((out)) = (int32_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 4;
			}
		}
		
		out += (obps);
	}
	return n;
}

int copy_sep_stereo_1_mono_4(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 1;
	for(i = (long) in; i < end; i+= 1) {
		{
			int32_t s1 = *(int8_t*)(p+(i));
			int32_t s2 = *(int8_t*)(q+(i));
			*(int32_t*)((out)) = (int32_t)((conv)((s1 + s2) / 2, (channels)));
		}
		
		out += (4);
	}
	return n;
}

int copy_sep_multi_1_mono_4(char* in, char* out, long n)
{

	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 1;
	for(i = (long) in; i < end; i+= 1) {
		{
			int c = 0;
			int64_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int8_t*)(input_data[c]+(i)), &(channels)[c]);
			} while(c < ichan);
			*(int32_t*)((out)) = (int32_t)(samp/ichan);
		}
		out += (4);
	}
	return n;
}


int resample_sep_stereo_1_stereo_4(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 1;
	int inc2 = st->inc2 * 1;
	long i, j;
	long jend = (long) in + nin * 1;
	long iend = nout * (2*(4));
	for(i = 0, j = (long) in; i < iend && j < jend; i += (2*(4))) {
		{
			*(int32_t*)(((out + i))) = (int32_t)((conv)(*(int8_t*)(p+(j)), (channels)));
			*(int32_t*)(((out + i))+4) = (int32_t)((conv)(*(int8_t*)(q+(j)), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 1;
	return i / (2*(4));
}

int resample_sep_multi_1_multi_4(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 1;
	int inc2 = st->inc2 * 1;
	long i, j;
	long jend = (long) in + nin * 1;
	long iend = nout * (obps);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int8_t*)(input_data[ic] + (j));
				*(int32_t*)(((out + i))) = (int32_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 4;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 1;
	return i / (obps);
}

int resample_sep_stereo_1_mono_4(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 1;
	int inc2 = st->inc2 * 1;
	long i, j;
	long jend = (long) in + nin * 1;
	long iend = nout * (4);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (4)) {
		{
			int32_t s1 = *(int8_t*)(p+(j));
			int32_t s2 = *(int8_t*)(q+(j));
			*(int32_t*)(((out + i))) = (int32_t)((conv)((s1 + s2) / 2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 1;
	return i / (4);
}

int resample_sep_multi_1_mono_4(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 1;
	int inc2 = st->inc2 * 1;
	long i, j;
	long jend = (long) in + nin * 1;
	long iend = nout * (4);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (4)) {
		{
			int c = 0;
			int64_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int8_t*)(input_data[c]+(j)), &(channels)[c]);
			} while(c < ichan);
			*(int32_t*)(((out + i))) = (int32_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 1;
	return i / (4);
}


int copy_sep_stereo_2_stereo_1(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 2;
	for(i = (long) in; i < end; i+= 2) {
		{
			*(int8_t*)((out)) = (int8_t)((conv)(*(int16_t*)(p+(i)), (channels)));
			*(int8_t*)((out)+1) = (int8_t)((conv)(*(int16_t*)(q+(i)), (channels)+1));
		}
		out += (2*(1));
	}
	return n;
}

int copy_sep_multi_2_multi_1(char* in, char* out, long n)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 2;
	for(i = (long) in; i < end; i+= 2) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int16_t*)(input_data[ic] + (i));
				*(int8_t*)((out)) = (int8_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 1;
			}
		}
		
		out += (obps);
	}
	return n;
}

int copy_sep_stereo_2_mono_1(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 2;
	for(i = (long) in; i < end; i+= 2) {
		{
			int32_t s1 = *(int16_t*)(p+(i));
			int32_t s2 = *(int16_t*)(q+(i));
			*(int8_t*)((out)) = (int8_t)((conv)((s1 + s2) / 2, (channels)));
		}
		
		out += (1);
	}
	return n;
}

int copy_sep_multi_2_mono_1(char* in, char* out, long n)
{

	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 2;
	for(i = (long) in; i < end; i+= 2) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int16_t*)(input_data[c]+(i)), &(channels)[c]);
			} while(c < ichan);
			*(int8_t*)((out)) = (int8_t)(samp/ichan);
		}
		out += (1);
	}
	return n;
}


int resample_sep_stereo_2_stereo_1(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 2;
	int inc2 = st->inc2 * 2;
	long i, j;
	long jend = (long) in + nin * 2;
	long iend = nout * (2*(1));
	for(i = 0, j = (long) in; i < iend && j < jend; i += (2*(1))) {
		{
			*(int8_t*)(((out + i))) = (int8_t)((conv)(*(int16_t*)(p+(j)), (channels)));
			*(int8_t*)(((out + i))+1) = (int8_t)((conv)(*(int16_t*)(q+(j)), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 2;
	return i / (2*(1));
}

int resample_sep_multi_2_multi_1(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 2;
	int inc2 = st->inc2 * 2;
	long i, j;
	long jend = (long) in + nin * 2;
	long iend = nout * (obps);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int16_t*)(input_data[ic] + (j));
				*(int8_t*)(((out + i))) = (int8_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 1;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 2;
	return i / (obps);
}

int resample_sep_stereo_2_mono_1(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 2;
	int inc2 = st->inc2 * 2;
	long i, j;
	long jend = (long) in + nin * 2;
	long iend = nout * (1);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (1)) {
		{
			int32_t s1 = *(int16_t*)(p+(j));
			int32_t s2 = *(int16_t*)(q+(j));
			*(int8_t*)(((out + i))) = (int8_t)((conv)((s1 + s2) / 2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 2;
	return i / (1);
}

int resample_sep_multi_2_mono_1(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 2;
	int inc2 = st->inc2 * 2;
	long i, j;
	long jend = (long) in + nin * 2;
	long iend = nout * (1);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (1)) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int16_t*)(input_data[c]+(j)), &(channels)[c]);
			} while(c < ichan);
			*(int8_t*)(((out + i))) = (int8_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 2;
	return i / (1);
}


int copy_sep_stereo_2_stereo_2(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 2;
	for(i = (long) in; i < end; i+= 2) {
		{
			*(int16_t*)((out)) = (int16_t)((conv)(*(int16_t*)(p+(i)), (channels)));
			*(int16_t*)((out)+2) = (int16_t)((conv)(*(int16_t*)(q+(i)), (channels)+1));
		}
		out += (2*(2));
	}
	return n;
}

int copy_sep_multi_2_multi_2(char* in, char* out, long n)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 2;
	for(i = (long) in; i < end; i+= 2) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int16_t*)(input_data[ic] + (i));
				*(int16_t*)((out)) = (int16_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 2;
			}
		}
		
		out += (obps);
	}
	return n;
}

int copy_sep_stereo_2_mono_2(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 2;
	for(i = (long) in; i < end; i+= 2) {
		{
			int32_t s1 = *(int16_t*)(p+(i));
			int32_t s2 = *(int16_t*)(q+(i));
			*(int16_t*)((out)) = (int16_t)((conv)((s1 + s2) / 2, (channels)));
		}
		
		out += (2);
	}
	return n;
}

int copy_sep_multi_2_mono_2(char* in, char* out, long n)
{

	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 2;
	for(i = (long) in; i < end; i+= 2) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int16_t*)(input_data[c]+(i)), &(channels)[c]);
			} while(c < ichan);
			*(int16_t*)((out)) = (int16_t)(samp/ichan);
		}
		out += (2);
	}
	return n;
}


int resample_sep_stereo_2_stereo_2(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 2;
	int inc2 = st->inc2 * 2;
	long i, j;
	long jend = (long) in + nin * 2;
	long iend = nout * (2*(2));
	for(i = 0, j = (long) in; i < iend && j < jend; i += (2*(2))) {
		{
			*(int16_t*)(((out + i))) = (int16_t)((conv)(*(int16_t*)(p+(j)), (channels)));
			*(int16_t*)(((out + i))+2) = (int16_t)((conv)(*(int16_t*)(q+(j)), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 2;
	return i / (2*(2));
}

int resample_sep_multi_2_multi_2(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 2;
	int inc2 = st->inc2 * 2;
	long i, j;
	long jend = (long) in + nin * 2;
	long iend = nout * (obps);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int16_t*)(input_data[ic] + (j));
				*(int16_t*)(((out + i))) = (int16_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 2;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 2;
	return i / (obps);
}

int resample_sep_stereo_2_mono_2(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 2;
	int inc2 = st->inc2 * 2;
	long i, j;
	long jend = (long) in + nin * 2;
	long iend = nout * (2);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (2)) {
		{
			int32_t s1 = *(int16_t*)(p+(j));
			int32_t s2 = *(int16_t*)(q+(j));
			*(int16_t*)(((out + i))) = (int16_t)((conv)((s1 + s2) / 2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 2;
	return i / (2);
}

int resample_sep_multi_2_mono_2(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 2;
	int inc2 = st->inc2 * 2;
	long i, j;
	long jend = (long) in + nin * 2;
	long iend = nout * (2);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (2)) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int16_t*)(input_data[c]+(j)), &(channels)[c]);
			} while(c < ichan);
			*(int16_t*)(((out + i))) = (int16_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 2;
	return i / (2);
}


int copy_sep_stereo_2_stereo_4(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 2;
	for(i = (long) in; i < end; i+= 2) {
		{
			*(int32_t*)((out)) = (int32_t)((conv)(*(int16_t*)(p+(i)), (channels)));
			*(int32_t*)((out)+4) = (int32_t)((conv)(*(int16_t*)(q+(i)), (channels)+1));
		}
		out += (2*(4));
	}
	return n;
}

int copy_sep_multi_2_multi_4(char* in, char* out, long n)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 2;
	for(i = (long) in; i < end; i+= 2) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int16_t*)(input_data[ic] + (i));
				*(int32_t*)((out)) = (int32_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 4;
			}
		}
		
		out += (obps);
	}
	return n;
}

int copy_sep_stereo_2_mono_4(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 2;
	for(i = (long) in; i < end; i+= 2) {
		{
			int32_t s1 = *(int16_t*)(p+(i));
			int32_t s2 = *(int16_t*)(q+(i));
			*(int32_t*)((out)) = (int32_t)((conv)((s1 + s2) / 2, (channels)));
		}
		
		out += (4);
	}
	return n;
}

int copy_sep_multi_2_mono_4(char* in, char* out, long n)
{

	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 2;
	for(i = (long) in; i < end; i+= 2) {
		{
			int c = 0;
			int64_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int16_t*)(input_data[c]+(i)), &(channels)[c]);
			} while(c < ichan);
			*(int32_t*)((out)) = (int32_t)(samp/ichan);
		}
		out += (4);
	}
	return n;
}


int resample_sep_stereo_2_stereo_4(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 2;
	int inc2 = st->inc2 * 2;
	long i, j;
	long jend = (long) in + nin * 2;
	long iend = nout * (2*(4));
	for(i = 0, j = (long) in; i < iend && j < jend; i += (2*(4))) {
		{
			*(int32_t*)(((out + i))) = (int32_t)((conv)(*(int16_t*)(p+(j)), (channels)));
			*(int32_t*)(((out + i))+4) = (int32_t)((conv)(*(int16_t*)(q+(j)), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 2;
	return i / (2*(4));
}

int resample_sep_multi_2_multi_4(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 2;
	int inc2 = st->inc2 * 2;
	long i, j;
	long jend = (long) in + nin * 2;
	long iend = nout * (obps);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int16_t*)(input_data[ic] + (j));
				*(int32_t*)(((out + i))) = (int32_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 4;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 2;
	return i / (obps);
}

int resample_sep_stereo_2_mono_4(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 2;
	int inc2 = st->inc2 * 2;
	long i, j;
	long jend = (long) in + nin * 2;
	long iend = nout * (4);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (4)) {
		{
			int32_t s1 = *(int16_t*)(p+(j));
			int32_t s2 = *(int16_t*)(q+(j));
			*(int32_t*)(((out + i))) = (int32_t)((conv)((s1 + s2) / 2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 2;
	return i / (4);
}

int resample_sep_multi_2_mono_4(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 2;
	int inc2 = st->inc2 * 2;
	long i, j;
	long jend = (long) in + nin * 2;
	long iend = nout * (4);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (4)) {
		{
			int c = 0;
			int64_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int16_t*)(input_data[c]+(j)), &(channels)[c]);
			} while(c < ichan);
			*(int32_t*)(((out + i))) = (int32_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 2;
	return i / (4);
}


int copy_sep_stereo_4_stereo_1(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 4;
	for(i = (long) in; i < end; i+= 4) {
		{
			*(int8_t*)((out)) = (int8_t)((conv)(*(int32_t*)(p+(i)), (channels)));
			*(int8_t*)((out)+1) = (int8_t)((conv)(*(int32_t*)(q+(i)), (channels)+1));
		}
		out += (2*(1));
	}
	return n;
}

int copy_sep_multi_4_multi_1(char* in, char* out, long n)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 4;
	for(i = (long) in; i < end; i+= 4) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int32_t*)(input_data[ic] + (i));
				*(int8_t*)((out)) = (int8_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 1;
			}
		}
		
		out += (obps);
	}
	return n;
}

int copy_sep_stereo_4_mono_1(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 4;
	for(i = (long) in; i < end; i+= 4) {
		{
			int32_t s1 = *(int32_t*)(p+(i)) / 2;
			int32_t s2 = *(int32_t*)(q+(i)) / 2;
			*(int8_t*)((out)) = (int8_t)((conv)(s1 + s2, (channels)));
		}
		
		out += (1);
	}
	return n;
}

int copy_sep_multi_4_mono_1(char* in, char* out, long n)
{

	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 4;
	for(i = (long) in; i < end; i+= 4) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int32_t*)(input_data[c]+(i)), &(channels)[c]);
			} while(c < ichan);
			*(int8_t*)((out)) = (int8_t)(samp/ichan);
		}
		out += (1);
	}
	return n;
}


int resample_sep_stereo_4_stereo_1(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 4;
	int inc2 = st->inc2 * 4;
	long i, j;
	long jend = (long) in + nin * 4;
	long iend = nout * (2*(1));
	for(i = 0, j = (long) in; i < iend && j < jend; i += (2*(1))) {
		{
			*(int8_t*)(((out + i))) = (int8_t)((conv)(*(int32_t*)(p+(j)), (channels)));
			*(int8_t*)(((out + i))+1) = (int8_t)((conv)(*(int32_t*)(q+(j)), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 4;
	return i / (2*(1));
}

int resample_sep_multi_4_multi_1(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 4;
	int inc2 = st->inc2 * 4;
	long i, j;
	long jend = (long) in + nin * 4;
	long iend = nout * (obps);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int32_t*)(input_data[ic] + (j));
				*(int8_t*)(((out + i))) = (int8_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 1;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 4;
	return i / (obps);
}

int resample_sep_stereo_4_mono_1(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 4;
	int inc2 = st->inc2 * 4;
	long i, j;
	long jend = (long) in + nin * 4;
	long iend = nout * (1);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (1)) {
		{
			int32_t s1 = *(int32_t*)(p+(j)) / 2;
			int32_t s2 = *(int32_t*)(q+(j)) / 2;
			*(int8_t*)(((out + i))) = (int8_t)((conv)(s1 + s2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 4;
	return i / (1);
}

int resample_sep_multi_4_mono_1(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 4;
	int inc2 = st->inc2 * 4;
	long i, j;
	long jend = (long) in + nin * 4;
	long iend = nout * (1);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (1)) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int32_t*)(input_data[c]+(j)), &(channels)[c]);
			} while(c < ichan);
			*(int8_t*)(((out + i))) = (int8_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 4;
	return i / (1);
}


int copy_sep_stereo_4_stereo_2(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 4;
	for(i = (long) in; i < end; i+= 4) {
		{
			*(int16_t*)((out)) = (int16_t)((conv)(*(int32_t*)(p+(i)), (channels)));
			*(int16_t*)((out)+2) = (int16_t)((conv)(*(int32_t*)(q+(i)), (channels)+1));
		}
		out += (2*(2));
	}
	return n;
}

int copy_sep_multi_4_multi_2(char* in, char* out, long n)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 4;
	for(i = (long) in; i < end; i+= 4) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int32_t*)(input_data[ic] + (i));
				*(int16_t*)((out)) = (int16_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 2;
			}
		}
		
		out += (obps);
	}
	return n;
}

int copy_sep_stereo_4_mono_2(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 4;
	for(i = (long) in; i < end; i+= 4) {
		{
			int32_t s1 = *(int32_t*)(p+(i)) / 2;
			int32_t s2 = *(int32_t*)(q+(i)) / 2;
			*(int16_t*)((out)) = (int16_t)((conv)(s1 + s2, (channels)));
		}
		
		out += (2);
	}
	return n;
}

int copy_sep_multi_4_mono_2(char* in, char* out, long n)
{

	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 4;
	for(i = (long) in; i < end; i+= 4) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int32_t*)(input_data[c]+(i)), &(channels)[c]);
			} while(c < ichan);
			*(int16_t*)((out)) = (int16_t)(samp/ichan);
		}
		out += (2);
	}
	return n;
}


int resample_sep_stereo_4_stereo_2(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 4;
	int inc2 = st->inc2 * 4;
	long i, j;
	long jend = (long) in + nin * 4;
	long iend = nout * (2*(2));
	for(i = 0, j = (long) in; i < iend && j < jend; i += (2*(2))) {
		{
			*(int16_t*)(((out + i))) = (int16_t)((conv)(*(int32_t*)(p+(j)), (channels)));
			*(int16_t*)(((out + i))+2) = (int16_t)((conv)(*(int32_t*)(q+(j)), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 4;
	return i / (2*(2));
}

int resample_sep_multi_4_multi_2(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 4;
	int inc2 = st->inc2 * 4;
	long i, j;
	long jend = (long) in + nin * 4;
	long iend = nout * (obps);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int32_t*)(input_data[ic] + (j));
				*(int16_t*)(((out + i))) = (int16_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 2;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 4;
	return i / (obps);
}

int resample_sep_stereo_4_mono_2(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 4;
	int inc2 = st->inc2 * 4;
	long i, j;
	long jend = (long) in + nin * 4;
	long iend = nout * (2);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (2)) {
		{
			int32_t s1 = *(int32_t*)(p+(j)) / 2;
			int32_t s2 = *(int32_t*)(q+(j)) / 2;
			*(int16_t*)(((out + i))) = (int16_t)((conv)(s1 + s2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 4;
	return i / (2);
}

int resample_sep_multi_4_mono_2(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 4;
	int inc2 = st->inc2 * 4;
	long i, j;
	long jend = (long) in + nin * 4;
	long iend = nout * (2);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (2)) {
		{
			int c = 0;
			int32_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int32_t*)(input_data[c]+(j)), &(channels)[c]);
			} while(c < ichan);
			*(int16_t*)(((out + i))) = (int16_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 4;
	return i / (2);
}


int copy_sep_stereo_4_stereo_4(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 4;
	for(i = (long) in; i < end; i+= 4) {
		{
			*(int32_t*)((out)) = (int32_t)((conv)(*(int32_t*)(p+(i)), (channels)));
			*(int32_t*)((out)+4) = (int32_t)((conv)(*(int32_t*)(q+(i)), (channels)+1));
		}
		out += (2*(4));
	}
	return n;
}

int copy_sep_multi_4_multi_4(char* in, char* out, long n)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 4;
	for(i = (long) in; i < end; i+= 4) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int32_t*)(input_data[ic] + (i));
				*(int32_t*)((out)) = (int32_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 4;
			}
		}
		
		out += (obps);
	}
	return n;
}

int copy_sep_stereo_4_mono_4(char* in, char* out, long n)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 4;
	for(i = (long) in; i < end; i+= 4) {
		{
			int32_t s1 = *(int32_t*)(p+(i)) / 2;
			int32_t s2 = *(int32_t*)(q+(i)) / 2;
			*(int32_t*)((out)) = (int32_t)((conv)(s1 + s2, (channels)));
		}
		
		out += (4);
	}
	return n;
}

int copy_sep_multi_4_mono_4(char* in, char* out, long n)
{

	convert_channel_func conv = convert_chan;
	long i, end = (long) in + n * 4;
	for(i = (long) in; i < end; i+= 4) {
		{
			int c = 0;
			int64_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int32_t*)(input_data[c]+(i)), &(channels)[c]);
			} while(c < ichan);
			*(int32_t*)((out)) = (int32_t)(samp/ichan);
		}
		out += (4);
	}
	return n;
}


int resample_sep_stereo_4_stereo_4(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 4;
	int inc2 = st->inc2 * 4;
	long i, j;
	long jend = (long) in + nin * 4;
	long iend = nout * (2*(4));
	for(i = 0, j = (long) in; i < iend && j < jend; i += (2*(4))) {
		{
			*(int32_t*)(((out + i))) = (int32_t)((conv)(*(int32_t*)(p+(j)), (channels)));
			*(int32_t*)(((out + i))+4) = (int32_t)((conv)(*(int32_t*)(q+(j)), (channels)+1));
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 4;
	return i / (2*(4));
}

int resample_sep_multi_4_multi_4(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

int obps = out_bps; /* load into register (or cache)*/
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 4;
	int inc2 = st->inc2 * 4;
	long i, j;
	long jend = (long) in + nin * 4;
	long iend = nout * (obps);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (obps)) {
		{
			int ic = 0, oc = 0;
			int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
			while(1) {
				int32_t samp = *(int32_t*)(input_data[ic] + (j));
				*(int32_t*)(((out + i))) = (int32_t)((conv)(samp, &(channels)[ic]));
				if(++oc >= ochan) break;
				/* N.B. this (below) causes redundant convert_chan calls */
				/* N.B. moreover, this does not work with dithering, cause it has
			   a state which changes from one call to another.
				   >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
				*/
				if(++ic >= ichan) ichan = 0;
				out += 4;
			}
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 4;
	return i / (obps);
}

int resample_sep_stereo_4_mono_4(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{
	char *p = input_data[0], *q = input_data[1];
	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 4;
	int inc2 = st->inc2 * 4;
	long i, j;
	long jend = (long) in + nin * 4;
	long iend = nout * (4);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (4)) {
		{
			int32_t s1 = *(int32_t*)(p+(j)) / 2;
			int32_t s2 = *(int32_t*)(q+(j)) / 2;
			*(int32_t*)(((out + i))) = (int32_t)((conv)(s1 + s2, (channels)));
		}
		
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 4;
	return i / (4);
}

int resample_sep_multi_4_mono_4(char* in, char* out,
			  long nin, long nout, long* ni, resample_state* st)
{

	convert_channel_func conv = convert_chan;
	int inc1 = st->inc1 * 4;
	int inc2 = st->inc2 * 4;
	long i, j;
	long jend = (long) in + nin * 4;
	long iend = nout * (4);
	for(i = 0, j = (long) in; i < iend && j < jend; i += (4)) {
		{
			int c = 0;
			int64_t samp = 0;
			int ichan = in_fmt.chan;
			do {
				samp += (conv)(*(int32_t*)(input_data[c]+(j)), &(channels)[c]);
			} while(c < ichan);
			*(int32_t*)(((out + i))) = (int32_t)(samp/ichan);
		}
		if(st->state >= 0) {
			st->state += st->step2;
			j += inc2;
		} else {
			st->state += st->step1;
			j += inc1;
		}
	}
	if(ni) *ni = (j - (long) in) / 4;
	return i / (4);
}


copy_func copy_tab[3][3][4][4] =
{ 
	{ /* input channels: "mono" */
		{ /* output channels: "mono" */
			{
				copy_mono_1_mono_1,
				copy_mono_1_mono_2,
				NULL /* obpc=3 invalid*/,
				copy_mono_1_mono_4
			},
			{
				copy_mono_2_mono_1,
				copy_mono_2_mono_2,
				NULL /* obpc=3 invalid*/,
				copy_mono_2_mono_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				copy_mono_4_mono_1,
				copy_mono_4_mono_2,
				NULL /* obpc=3 invalid*/,
				copy_mono_4_mono_4
			}
		},
		{ /* output channels: "stereo" */
			{
				copy_multi_1_multi_1,
				copy_multi_1_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_1_multi_4
			},
			{
				copy_multi_2_multi_1,
				copy_multi_2_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_2_multi_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				copy_multi_4_multi_1,
				copy_multi_4_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_4_multi_4
			}
		},
		{ /* output channels: "multi" */
			{
				copy_multi_1_multi_1,
				copy_multi_1_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_1_multi_4
			},
			{
				copy_multi_2_multi_1,
				copy_multi_2_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_2_multi_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				copy_multi_4_multi_1,
				copy_multi_4_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_4_multi_4
			}
		}
	},
	{ /* input channels: "stereo" */
		{ /* output channels: "mono" */
			{
				copy_stereo_1_mono_1,
				copy_stereo_1_mono_2,
				NULL /* obpc=3 invalid*/,
				copy_stereo_1_mono_4
			},
			{
				copy_stereo_2_mono_1,
				copy_stereo_2_mono_2,
				NULL /* obpc=3 invalid*/,
				copy_stereo_2_mono_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				copy_stereo_4_mono_1,
				copy_stereo_4_mono_2,
				NULL /* obpc=3 invalid*/,
				copy_stereo_4_mono_4
			}
		},
		{ /* output channels: "stereo" */
			{
				copy_stereo_1_stereo_1,
				copy_stereo_1_stereo_2,
				NULL /* obpc=3 invalid*/,
				copy_stereo_1_stereo_4
			},
			{
				copy_stereo_2_stereo_1,
				copy_stereo_2_stereo_2,
				NULL /* obpc=3 invalid*/,
				copy_stereo_2_stereo_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				copy_stereo_4_stereo_1,
				copy_stereo_4_stereo_2,
				NULL /* obpc=3 invalid*/,
				copy_stereo_4_stereo_4
			}
		},
		{ /* output channels: "multi" */
			{
				copy_multi_1_multi_1,
				copy_multi_1_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_1_multi_4
			},
			{
				copy_multi_2_multi_1,
				copy_multi_2_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_2_multi_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				copy_multi_4_multi_1,
				copy_multi_4_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_4_multi_4
			}
		}
	},
	{ /* input channels: "multi" */
		{ /* output channels: "mono" */
			{
				copy_multi_1_mono_1,
				copy_multi_1_mono_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_1_mono_4
			},
			{
				copy_multi_2_mono_1,
				copy_multi_2_mono_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_2_mono_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				copy_multi_4_mono_1,
				copy_multi_4_mono_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_4_mono_4
			}
		},
		{ /* output channels: "stereo" */
			{
				copy_multi_1_multi_1,
				copy_multi_1_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_1_multi_4
			},
			{
				copy_multi_2_multi_1,
				copy_multi_2_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_2_multi_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				copy_multi_4_multi_1,
				copy_multi_4_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_4_multi_4
			}
		},
		{ /* output channels: "multi" */
			{
				copy_multi_1_multi_1,
				copy_multi_1_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_1_multi_4
			},
			{
				copy_multi_2_multi_1,
				copy_multi_2_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_2_multi_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				copy_multi_4_multi_1,
				copy_multi_4_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_multi_4_multi_4
			}
		}
	}
};

resample_func resample_tab[3][3][4][4] =
{ 
	{ /* input channels: "mono" */
		{ /* output channels: "mono" */
			{
				resample_mono_1_mono_1,
				resample_mono_1_mono_2,
				NULL /* obpc=3 invalid*/,
				resample_mono_1_mono_4
			},
			{
				resample_mono_2_mono_1,
				resample_mono_2_mono_2,
				NULL /* obpc=3 invalid*/,
				resample_mono_2_mono_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				resample_mono_4_mono_1,
				resample_mono_4_mono_2,
				NULL /* obpc=3 invalid*/,
				resample_mono_4_mono_4
			}
		},
		{ /* output channels: "stereo" */
			{
				resample_multi_1_multi_1,
				resample_multi_1_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_1_multi_4
			},
			{
				resample_multi_2_multi_1,
				resample_multi_2_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_2_multi_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				resample_multi_4_multi_1,
				resample_multi_4_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_4_multi_4
			}
		},
		{ /* output channels: "multi" */
			{
				resample_multi_1_multi_1,
				resample_multi_1_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_1_multi_4
			},
			{
				resample_multi_2_multi_1,
				resample_multi_2_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_2_multi_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				resample_multi_4_multi_1,
				resample_multi_4_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_4_multi_4
			}
		}
	},
	{ /* input channels: "stereo" */
		{ /* output channels: "mono" */
			{
				resample_stereo_1_mono_1,
				resample_stereo_1_mono_2,
				NULL /* obpc=3 invalid*/,
				resample_stereo_1_mono_4
			},
			{
				resample_stereo_2_mono_1,
				resample_stereo_2_mono_2,
				NULL /* obpc=3 invalid*/,
				resample_stereo_2_mono_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				resample_stereo_4_mono_1,
				resample_stereo_4_mono_2,
				NULL /* obpc=3 invalid*/,
				resample_stereo_4_mono_4
			}
		},
		{ /* output channels: "stereo" */
			{
				resample_stereo_1_stereo_1,
				resample_stereo_1_stereo_2,
				NULL /* obpc=3 invalid*/,
				resample_stereo_1_stereo_4
			},
			{
				resample_stereo_2_stereo_1,
				resample_stereo_2_stereo_2,
				NULL /* obpc=3 invalid*/,
				resample_stereo_2_stereo_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				resample_stereo_4_stereo_1,
				resample_stereo_4_stereo_2,
				NULL /* obpc=3 invalid*/,
				resample_stereo_4_stereo_4
			}
		},
		{ /* output channels: "multi" */
			{
				resample_multi_1_multi_1,
				resample_multi_1_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_1_multi_4
			},
			{
				resample_multi_2_multi_1,
				resample_multi_2_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_2_multi_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				resample_multi_4_multi_1,
				resample_multi_4_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_4_multi_4
			}
		}
	},
	{ /* input channels: "multi" */
		{ /* output channels: "mono" */
			{
				resample_multi_1_mono_1,
				resample_multi_1_mono_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_1_mono_4
			},
			{
				resample_multi_2_mono_1,
				resample_multi_2_mono_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_2_mono_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				resample_multi_4_mono_1,
				resample_multi_4_mono_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_4_mono_4
			}
		},
		{ /* output channels: "stereo" */
			{
				resample_multi_1_multi_1,
				resample_multi_1_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_1_multi_4
			},
			{
				resample_multi_2_multi_1,
				resample_multi_2_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_2_multi_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				resample_multi_4_multi_1,
				resample_multi_4_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_4_multi_4
			}
		},
		{ /* output channels: "multi" */
			{
				resample_multi_1_multi_1,
				resample_multi_1_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_1_multi_4
			},
			{
				resample_multi_2_multi_1,
				resample_multi_2_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_2_multi_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				resample_multi_4_multi_1,
				resample_multi_4_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_multi_4_multi_4
			}
		}
	}
};

copy_func copy_sep_tab[2][3][4][4] =
{ 
	{ /* input channels: "stereo" */
		{ /* output channels: "mono" */
			{
				copy_sep_stereo_1_mono_1,
				copy_sep_stereo_1_mono_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_stereo_1_mono_4
			},
			{
				copy_sep_stereo_2_mono_1,
				copy_sep_stereo_2_mono_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_stereo_2_mono_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				copy_sep_stereo_4_mono_1,
				copy_sep_stereo_4_mono_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_stereo_4_mono_4
			}
		},
		{ /* output channels: "stereo" */
			{
				copy_sep_stereo_1_stereo_1,
				copy_sep_stereo_1_stereo_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_stereo_1_stereo_4
			},
			{
				copy_sep_stereo_2_stereo_1,
				copy_sep_stereo_2_stereo_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_stereo_2_stereo_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				copy_sep_stereo_4_stereo_1,
				copy_sep_stereo_4_stereo_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_stereo_4_stereo_4
			}
		},
		{ /* output channels: "multi" */
			{
				copy_sep_multi_1_multi_1,
				copy_sep_multi_1_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_multi_1_multi_4
			},
			{
				copy_sep_multi_2_multi_1,
				copy_sep_multi_2_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_multi_2_multi_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				copy_sep_multi_4_multi_1,
				copy_sep_multi_4_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_multi_4_multi_4
			}
		}
	},
	{ /* input channels: "multi" */
		{ /* output channels: "mono" */
			{
				copy_sep_multi_1_mono_1,
				copy_sep_multi_1_mono_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_multi_1_mono_4
			},
			{
				copy_sep_multi_2_mono_1,
				copy_sep_multi_2_mono_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_multi_2_mono_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				copy_sep_multi_4_mono_1,
				copy_sep_multi_4_mono_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_multi_4_mono_4
			}
		},
		{ /* output channels: "stereo" */
			{
				copy_sep_multi_1_multi_1,
				copy_sep_multi_1_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_multi_1_multi_4
			},
			{
				copy_sep_multi_2_multi_1,
				copy_sep_multi_2_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_multi_2_multi_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				copy_sep_multi_4_multi_1,
				copy_sep_multi_4_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_multi_4_multi_4
			}
		},
		{ /* output channels: "multi" */
			{
				copy_sep_multi_1_multi_1,
				copy_sep_multi_1_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_multi_1_multi_4
			},
			{
				copy_sep_multi_2_multi_1,
				copy_sep_multi_2_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_multi_2_multi_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				copy_sep_multi_4_multi_1,
				copy_sep_multi_4_multi_2,
				NULL /* obpc=3 invalid*/,
				copy_sep_multi_4_multi_4
			}
		}
	}
};

resample_func resample_sep_tab[2][3][4][4] =
{ 
	{ /* input channels: "stereo" */
		{ /* output channels: "mono" */
			{
				resample_sep_stereo_1_mono_1,
				resample_sep_stereo_1_mono_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_stereo_1_mono_4
			},
			{
				resample_sep_stereo_2_mono_1,
				resample_sep_stereo_2_mono_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_stereo_2_mono_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				resample_sep_stereo_4_mono_1,
				resample_sep_stereo_4_mono_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_stereo_4_mono_4
			}
		},
		{ /* output channels: "stereo" */
			{
				resample_sep_stereo_1_stereo_1,
				resample_sep_stereo_1_stereo_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_stereo_1_stereo_4
			},
			{
				resample_sep_stereo_2_stereo_1,
				resample_sep_stereo_2_stereo_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_stereo_2_stereo_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				resample_sep_stereo_4_stereo_1,
				resample_sep_stereo_4_stereo_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_stereo_4_stereo_4
			}
		},
		{ /* output channels: "multi" */
			{
				resample_sep_multi_1_multi_1,
				resample_sep_multi_1_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_multi_1_multi_4
			},
			{
				resample_sep_multi_2_multi_1,
				resample_sep_multi_2_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_multi_2_multi_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				resample_sep_multi_4_multi_1,
				resample_sep_multi_4_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_multi_4_multi_4
			}
		}
	},
	{ /* input channels: "multi" */
		{ /* output channels: "mono" */
			{
				resample_sep_multi_1_mono_1,
				resample_sep_multi_1_mono_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_multi_1_mono_4
			},
			{
				resample_sep_multi_2_mono_1,
				resample_sep_multi_2_mono_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_multi_2_mono_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				resample_sep_multi_4_mono_1,
				resample_sep_multi_4_mono_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_multi_4_mono_4
			}
		},
		{ /* output channels: "stereo" */
			{
				resample_sep_multi_1_multi_1,
				resample_sep_multi_1_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_multi_1_multi_4
			},
			{
				resample_sep_multi_2_multi_1,
				resample_sep_multi_2_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_multi_2_multi_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				resample_sep_multi_4_multi_1,
				resample_sep_multi_4_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_multi_4_multi_4
			}
		},
		{ /* output channels: "multi" */
			{
				resample_sep_multi_1_multi_1,
				resample_sep_multi_1_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_multi_1_multi_4
			},
			{
				resample_sep_multi_2_multi_1,
				resample_sep_multi_2_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_multi_2_multi_4
			},
			{ NULL, NULL, NULL, NULL }, /* ibpc=3 invalid */
			{
				resample_sep_multi_4_multi_1,
				resample_sep_multi_4_multi_2,
				NULL /* obpc=3 invalid*/,
				resample_sep_multi_4_multi_4
			}
		}
	}
};

