/*
 * wmdimp
 * Copyright (c) 2004 Daniele Tamino <aslo@wmdimp.cjb.net>.
 * This software covered by the GPL.  See COPYING file for details.
 *
 * output_funcs.h
 *
 * Many little specialized functions to convert betwees audio formats
 * on the fly when playing.
 *
 */
dnl debugmode(`taeqcx')dnl
dnl little warning for generated file (THIS file can be edited)
/* file generated automatically from __file__: do not edit */
divert(-1)

dnl foreach(iter, list, text):
dnl   iterativaly define `iter' as each element in the comma-separated
dnl   list `list' and expanding `text'.
dnl
define(`__foreach',`$2`'ifelse(`$4', , ,`define(`$1', `$4')`'dnl
__foreach(`$1', `$2', shift(shift(shift($@))))')')dnl
define(`_foreach',
  `pushdef(`$1', `$3')__foreach($@)popdef(`$1')')dnl
define(`foreach',`_foreach(`$1', `$3', $2)')

dnl Enable the 2 following lines to debug
dnl traceon(`__foreach')dnl
dnl traceon(`traceon')dnl

dnl quote(x): add quotes to x
dnl  used to quote the expansion of some macro without avoiding the expansion
dnl define(`quote',`changequote(`!',`!')`changequote(!`!,!'!)$1`'dnl
dnl changequote(`!',`!')'changequote(!`!,!'!)')dnl

dnl indent(n, txt)
dnl  Add n * 4 spaces to the beginning of each line of txt.
dnl  Used to pretty format the output
define(`$rmbr', `substr(`$1', 1, eval(len(`$1')-2))')
define(`$nspaces', `ifelse(eval(`$1' > 0), 1,
    `    indir(`$nspaces', eval(`$1'-1))')')
define(`$indent', `patsubst(`indir(`$rmbr', `$2')', `^', indir(`$nspaces',`$1'))')
define(`indent', `indir(`$indent', `$1', ($2))')

dnl traceon(`indent', `_indent', `quote', `indir', `patsubst')

dnl define each of read_sample and write_sample as a m4 macro
dnl so they're surely expanded inline ;-)
dnl
define(`read_sample', `*(int`'eval($1*8)_t*)($2)')dnl
define(`write_sample',
   `*(int`'eval($1*8)_t*)($2) = (int`'eval($1*8)_t)($3)')dnl

dnl define the various conversion macros (each will output its c code)
foreach(`ibpc', `1, 2, 4', `foreach(`obpc', `1, 2, 4',
`
dnl
dnl conv_sample_A_ibpc_B_obpc(in, out, chan):
dnl   output the c code to convert a sample from in to out
dnl   using the specified (static) format and `chan' info.
define(`conv_sample_mono_'ibpc`_mono_'obpc,
`write_sample('obpc`, ($2), ($4)(read_sample('ibpc`, ($1)), ($3)));')
define(`conv_sample_stereo_'ibpc`_stereo_'obpc,
`{
    write_sample('obpc`, ($2), ($4)(read_sample('ibpc`, ($1)), ($3)));
    write_sample('obpc`, ($2)+'obpc`,
       ($4)(read_sample('ibpc`, ($1)+'ibpc`), ($3)+1));
}')
dnl traceon(`conv_sample_mono_'ibpc`_mono_'obpc)dnl
define(`conv_sample_multi_'ibpc`_multi_'obpc,
`{
    int ic = 0, oc = 0;
    int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
    while(1) {
        int32_t samp = read_sample('ibpc`, ($1));
        write_sample('obpc`, ($2), ($4)(samp, &($3)[ic]));
        if(++oc >= ochan) break;
        /* N.B. this (below) causes redundant convert_chan calls */
        if(++ic >= ichan) ichan = 0;
        in += 'ibpc`;
        out += 'obpc`;
    }
}
')dnl
dnl traceon(`conv_sample_multi_'ibpc`_multi_'obpc)dnl
# define(`conv_sample_stereo_'ibpc`_mono_'obpc,
# `{ifelse(eval('obpc` < 4), 1, `
#     int32_t s1 = ($4)(read_sample(''ibpc``, ($1)), ($3));
#     int32_t s2 = ($4)(read_sample(''ibpc``, ($1)+''ibpc``), ($3)+1);
#     write_sample(''obpc``, ($2), (s1 + s2)/2);
# ', `
#     int32_t s1 = ($4)(read_sample(''ibpc``, ($1)), ($3)) / 2;
#     int32_t s2 = ($4)(read_sample(''ibpc``, ($1)+''ibpc``), ($3)+1) / 2;
#     write_sample(''obpc``, ($2), s1 + s2);
# ')}
# ')dnl
dnl new (testing) version where "channels" applies to output chns instead of
dnl input channels; it saves a convert_chan calls and maybe sounds better
define(`conv_sample_stereo_'ibpc`_mono_'obpc,
`{ifelse(eval('ibpc` < 4), 1, `
    int32_t s1 = read_sample(''ibpc``, ($1));
    int32_t s2 = read_sample(''ibpc``, ($1)+''ibpc``);
    write_sample(''obpc``, ($2), ($4)((s1 + s2)/2, ($3)));
', `
    int32_t s1 = read_sample(''ibpc``, ($1)) / 2;
    int32_t s2 = read_sample(''ibpc``, ($1)+''ibpc``) / 2;
    write_sample(''obpc``, ($2), ($4)(s1 + s2, ($3)));
')}
')dnl
dnl traceon(`conv_sample_stereo_'ibpc`_mono_'obpc)dnl
define(`conv_sample_multi_'ibpc`_mono_'obpc,
`{
    int c = 0;
    ifelse(eval('obpc` < 4), 1, `int32_t', `int64_t') samp = 0;
    int ichan = in_fmt.chan;
    while(1) {
        samp += ($4)(read_sample('ibpc`, ($1)), &($3)[c]);
        if(c >= ichan) break;
        in += 'ibpc`;
    }
    write_sample('obpc`, ($2), samp/ichan);
}')dnl

dnl traceon(`conv_sample_multi_'ibpc`_mono_'obpc)dnl
dnl
dnl conv_sample_sep_A_ibpc_B_obpc:
dnl   output the c code to convert from format (A, ibpc) to (B, obpc)
dnl   These differs from the above only in the fact they read
dnl   input from `data(chn) + (long) in' instead of
dnl   `in + chn * ibpc'.
dnl   data(chn) is a m4 macro that expands to a pointer.
dnl   (conv_sample_sep_mono_?_mono_? is useless and so removed)
dnl
define(`conv_sample_sep_stereo_'ibpc`_stereo_'obpc,
`{
    write_sample('obpc`, ($2), ($4)(read_sample('ibpc`, data(0)+($1)), ($3)));
    write_sample('obpc`, ($2)+'obpc`,($4)(read_sample('ibpc`,
                 data(1)+($1)), ($3)+1));
}')dnl
define(`conv_sample_sep_multi_'ibpc`_multi_'obpc,
`{
    int ic = 0, oc = 0;
    int ichan = in_fmt.chan, ochan = out_fmt.chan; /* load globals */
    while(1) {
        int32_t samp = read_sample('ibpc`, data(ic) + ($1));
        write_sample('obpc`, ($2), ($4)(samp, &($3)[ic]));
        if(++oc >= ochan) break;
        /* N.B. this (below) causes redundant convert_chan calls */
        /* N.B. moreover, this does not work with dithering, cause it has
	   a state which changes from one call to another.
           >>>TODO: THIS IS A BUG AND MUST BE FIXED <<<
        */
        if(++ic >= ichan) ichan = 0;
        out += 'obpc`;
    }
}
')dnl
# define(`conv_sample_sep_stereo_'ibpc`_mono_'obpc,
# `{
# ifelse(eval('obpc` < 4), 1, 
# `    int32_t s1 = ($4)(read_sample(''ibpc``, data[0]+($1)), ($3));
#     int32_t s2 = ($4)(read_sample(''ibpc``, data[1]+($1)), ($3)+1);
#     write_sample(''obpc``, $2, (s1 + s2)/2);
# ',
# `    int32_t s1 = ($4)(read_sample(''ibpc``, data[0]+($1)), ($3))/2;
#     int32_t s2 = ($4)(read_sample(''ibpc``, data[1]+($1)), ($3)+1)/2;
#     write_sample(''obpc``, $2, s1 + s2);
# ')}
# ')dnl
dnl new version which calls convert_chan for every output (not input)
dnl channel; lets see (hear) if its better, surely its a little faster.
define(`conv_sample_sep_stereo_'ibpc`_mono_'obpc,
`{
ifelse(eval('ibpc` < 4), 1, 
`    int32_t s1 = read_sample(''ibpc``, data(0)+($1));
    int32_t s2 = read_sample(''ibpc``, data(1)+($1));
    write_sample(''obpc``, ($2), ($4)((s1 + s2) / 2, ($3)));
',
`    int32_t s1 = read_sample(''ibpc``, data(0)+($1)) / 2;
    int32_t s2 = read_sample(''ibpc``, data(1)+($1)) / 2;
    write_sample(''obpc``, ($2), ($4)(s1 + s2, ($3)));
')}
')

define(`conv_sample_sep_multi_'ibpc`_mono_'obpc,
`{
    int c = 0;
    ifelse(eval('obpc` < 4), 1, `int32_t', `int64_t') samp = 0;
    int ichan = in_fmt.chan;
    do {
        samp += ($4)(read_sample('ibpc`, data(c)+($1)), &($3)[c]);
    } while(c < ichan);
    write_sample('obpc`, ($2), samp/ichan);
}')dnl
')')dnl end of foreach(each couple of ibpc, obpc)
dnl makesuf(ichn, ibpc, ochn, obpc):
dnl  make suffix for given parameters if it exist, else default
dnl  on multi_ibpc_multi_obpc
define(`makesuf',
  `ifdef(`conv_sample_$1_$2_$3_$4',
         `$1_$2_$3_$4', `multi_$2_multi_$4')')

dnl chntype(nchan):
dnl   nchan = 1: output `mono'
dnl   nchan = 2: output `stereo'
dnl   else output `multi'
define(`chntype',`ifelse(`$1', 1, mono, `$1', 2, stereo, multi)')

dnl outbps(bpc, nch):
dnl   get a constant or variable to use in the code to stand for number of
dnl   output bytes per sample, given the "n. of channels" (1, 2 or many).
define(`outbps',`(ifelse(`$2', 1, `$1', `$2', 2, `2*($1)', `obps'))')

dnl inbps(bpc, nch):
dnl   get a constant or variable to use in the code to stand for number of
dnl   input bytes per sample, given the "n. of channels" (1, 2 or many).
define(`inbps',`(ifelse(`$2', 1, `$1', `$2', 2, `2*($1)', `ibps'))')

dnl data(n):
dnl   expands to a pointer used by conv_sample_sep_??? to access
dnl   the pointer to the n-th channel pointer.
define(`data', `ifelse(`$1', 0, `p', `$1', 1, `q', `input_data[$1]')')dnl
# traceon(`data')dnl
# dnl DEBUGGING
# divert
# /* `data' is defined as:
# defn(`data')
# */
# divert(-1)

dnl declare_copy(inchan, ibpc, onchan, obpc)
dnl  output the c function copy_A_ibpc_B_obpc
dnl  A = chntype(inchan), B = chntype(onchan)
define(`declare_copy',
`define(`suffix', `makesuf(chntype(`$1'),`$2',chntype(`$3'),`$4')')dnl
int copy_`'suffix`'(char* in, char* out, long n)
{
ifelse(eval(`$1' > 2), 1, `int ibps = in_bps; /* load into register (or cache)*/
')dnl
ifelse(eval(`$3' > 2), 1, `int obps = out_bps; /* load into register (or cache)*/
')dnl
    long i;
    convert_channel_func conv = convert_chan;
    for(i = 0; i < n; i++) {
indent(2, `indir(conv_sample_`'suffix, `in', `out', `channels', `conv')')
        in += inbps(`$2', `$1');
        out += outbps(`$4', `$3');
    }
    return n;
}
undefine(`suffix')')dnl
dnl declare_resample(inchan, ibpc, onchan, obpc)
dnl  output the c function resample_A_ibpc_B_obpc
dnl  A = chntype(inchan), B = chntype(onchan)
define(`declare_resample',
`define(`suffix', `makesuf(chntype(`$1'),`$2',chntype(`$3'),`$4')')dnl
int resample_`'suffix`'(char* in, char* out,
          long nin, long nout, long* ni, resample_state* st)
{
ifelse(eval(`$1' > 2), 1, `int ibps = in_bps; /* load into register (or cache)*/
')dnl
ifelse(eval(`$3' > 2), 1, `int obps = out_bps; /* load into register (or cache)*/
')dnl
    convert_channel_func conv = convert_chan;
    int inc1 = st->inc1 * inbps(`$2', `$1');
    int inc2 = st->inc2 * inbps(`$2', `$1');
    int i, j;
    nin *= inbps(`$2', `$1');
    nout *= outbps(`$4', `$3');
    for(i = 0, j = 0; i < nout && j < nin; i += outbps(`$4', `$3')) {
indent(2, `indir(conv_sample_`'suffix, `in + j', `out + i', `channels', `conv')')
        if(st->state >= 0) {
            st->state += st->step2;
            j += inc2;
        } else {
            st->state += st->step1;
            j += inc1;
        }
    }
    if(ni) *ni = j / inbps(`$2', `$1');
    return i / outbps(`$4', `$3');
}
undefine(`suffix')')dnl
dnl declare_copy_sep(inchan, ibpc, onchan, obpc)
dnl  output the c function copy_sep_A_ibpc_B_obpc
dnl  A = chntype(inchan), B = chntype(onchan)
define(`declare_copy_sep',
`define(`suffix', `makesuf(chntype(`$1'),`$2',chntype(`$3'),`$4')')dnl
dnl FINE DEBUGGING
int copy_sep_`'suffix`'(char* in, char* out, long n)
{
ifelse(`$1', 1, `    char *p = input_data[0];',
`$1', 2, `    char *p = input_data[0], *q = input_data[1];')
ifelse(eval(`$3' > 2), 1, `int obps = out_bps; /* load into register (or cache)*/
')dnl
    convert_channel_func conv = convert_chan;
    long i, end = (long) in + n * $2;
    for(i = (long) in; i < end; i+= $2) {
indent(2, `indir(conv_sample_sep_`'suffix, `i', `out', `channels', `conv')')
        out += outbps(`$4', `$3');
    }
    return n;
}
undefine(`suffix')')dnl
dnl declare_resample_sep(inchan, ibpc, onchan, obpc)
dnl  output the c function resample_sep_A_ibpc_B_obpc
dnl  A = chntype(inchan), B = chntype(onchan)
define(`declare_resample_sep',
`define(`suffix', `makesuf(chntype(`$1'),`$2',chntype(`$3'),`$4')')dnl
int resample_sep_`'suffix`'(char* in, char* out,
              long nin, long nout, long* ni, resample_state* st)
{
ifelse(`$1', 1, `    char *p = input_data[0];',
`$1', 2, `    char *p = input_data[0], *q = input_data[1];')
ifelse(eval(`$3' > 2), 1, `int obps = out_bps; /* load into register (or cache)*/
')dnl
    convert_channel_func conv = convert_chan;
    int inc1 = st->inc1 * $2;
    int inc2 = st->inc2 * $2;
    long i, j;
    long jend = (long) in + nin * $2;
    long iend = nout * outbps(`$4', `$3');
    for(i = 0, j = (long) in; i < iend && j < jend; i += outbps(`$4', `$3')) {
indent(2, `indir(conv_sample_sep_`'suffix, `j', `(out + i)', `channels',
       `conv')')
        if(st->state >= 0) {
            st->state += st->step2;
            j += inc2;
        } else {
            st->state += st->step1;
            j += inc1;
        }
    }
    if(ni) *ni = (j - (long) in) / $2;
    return i / outbps(`$4', `$3');
}
undefine(`suffix')')dnl
dnl declare_func(inchan, ibpc, onchan, obpc):
dnl   output the c function convert_sample_A_ibpc_B_obpc
dnl   where A is chntype(inchan) and B is chntype(onchan)
dnl   If the corresponding conv_sample*_A_ibpc_B_obpc isn't defined,
dnl   do nothing.
dnl   Kept for compatibility only.
dnl
define(`declare_func',
`ifdef(`conv_sample$1_'chntype(`$2')`_'chntype(`$4'),
`
void convert_sample$1_'chntype(`$2')`_$3_'chntype(`$4')`_$5
   (char* in, char* out, chan_info *ch) REGPARM;
void convert_sample$1_'chntype(`$2')`_$3_'chntype(`$4')`_$5
   (char* in, char* out, chan_info *ch)
{
  indir(`conv_sample$1_'chntype(`$2')`_$3_'chntype(`$4')`_$5',
        `in', `out', `ch')
}
')')dnl
dnl quote(txt) wrap txt with `' quotes
dnl define(`quote',`changequote(`[',`]')`changequote([`],['])$1`'dnl
dnl changequote(`[',`]')'changequote([`],['])')dnl
dnl declare_set(name, ibpc, obpc):
dnl   output the whole (known to be defined) set of
dnl   `copy'name_A_ibpc_B_obpc functions for the specified parameters.
define(`declare_set_copy',
`ifelse(`$1', `_sep', , `declare_copy$1(1, $2, 1, $3)')
declare_copy$1(2, $2, 2, $3)
declare_copy$1(3, $2, 3, $3)
declare_copy$1(2, $2, 1, $3)
declare_copy$1(3, $2, 1, $3)')dnl
dnl declare_set(name, ibpc, obpc):
dnl   output the whole (known to be defined) set of
dnl   `copy'name_A_ibpc_B_obpc functions for the specified parameters.
define(`declare_set_resample',
`ifelse(`$1', `_sep', , `declare_resample$1(1, $2, 1, $3)')
declare_resample$1(2, $2, 2, $3)
declare_resample$1(3, $2, 3, $3)
declare_resample$1(2, $2, 1, $3)
declare_resample$1(3, $2, 1, $3)')dnl
dnl traceon(`declare_copy',`declare_resample')dnl
dnl declare lookup table of all of those above
define(`declare_table',
`$2 $1_tab[3][3][4][4] =
{ foreach(`i', `mono, stereo, multi', `
    { /* input channels: "i" */foreach(`j', `mono, stereo, multi',`
        { /* output channels: "j" */foreach(`ibpc', `1, 2, 3, 4',
`ifelse(ibpc, 3, `
            { NULL, NULL, NULL, NULL }, /* `ibpc'=3 invalid */',`
            {foreach(`obpc', `1, 2, 3, 4', 
`ifelse(obpc, 3, `
                NULL /* `obpc'=3 invalid*/',`
                $1_`'makesuf(i, ibpc, j, obpc)')`'ifelse(obpc, 4, ,`,')')
            }ifelse(ibpc, 4, ,`,')')')
        }ifelse(j, multi, ,`,')')
    }ifelse(i, multi, ,`,')')
};
')
define(`declare_table_sep',
`$2 $1_sep_tab[2][3][4][4] =
{ foreach(`i', `stereo, multi', `
    { /* input channels: "i" */foreach(`j', `mono, stereo, multi',`
        { /* output channels: "j" */foreach(`ibpc', `1, 2, 3, 4',
`ifelse(ibpc, 3, `
            { NULL, NULL, NULL, NULL }, /* `ibpc'=3 invalid */',`
            {foreach(`obpc', `1, 2, 3, 4', 
`ifelse(obpc, 3, `
                NULL /* `obpc'=3 invalid*/',`
                $1_sep_`'makesuf(i, ibpc, j, obpc)')`'ifelse(obpc, 4, ,`,')')
            }ifelse(ibpc, 4, ,`,')')')
        }ifelse(j, multi, ,`,')')
    }ifelse(i, multi, ,`,')')
};
')

divert
dnl
dnl And now, finally, output all the good stuff
dnl
dnl output every possible copy/resample_A_ibpc_B_obpc
dnl use $i, $j to avoid unwanted expansions
foreach(`$i', `1, 2, 4', 
  `foreach(`$j', `1, 2, 4', 
`declare_set_copy(`', indir(`$i'), indir(`$j'))
declare_set_resample(`', indir(`$i'), indir(`$j'))
')')
dnl output every possible copy/resample_sep_A_ibpc_B_obpc
dnl use $i, $j to avoid unwanted expansions
foreach(`$i', `1, 2, 4', 
  `foreach(`$j', `1, 2, 4', 
`declare_set_copy(`_sep', indir(`$i'), indir(`$j'))
declare_set_resample(`_sep', indir(`$i'), indir(`$j'))
')')
dnl output lookup tables
declare_table(`copy', `copy_func')
declare_table(`resample', `resample_func')
declare_table_sep(`copy', `copy_func')
declare_table_sep(`resample', `resample_func')
