/*
 * wmdimp
 * Copyright (c) 2004 Daniele Tamino <arkaam@everyday.com>.
 * This software covered by the GPL.  See COPYING file for details.
 *
 * gui.c
 *
 * This file contains coordinates of the various gui elements.
 *
 */

#include <config.h>
#include "gui.h"
#include "wmdimp.xpm"
#include "charset.xpm"

char ** wmdimp_pixmap = wmdimp_xpm; /* cause wmdimp_xpm is declared static :-( */
char ** charset_pixmap = charset_xpm;

int char_width = 6;
int char_height = 7;

struct coord btn_pos[] = {
	{23, 36, 12, 11},	/* stop */
	{47, 36, 12, 11},	/* play */
	{35, 36, 12, 11},	/* pause */
	{35, 47, 12, 11},	/* back */
	{47, 47, 12, 11},	/* next */
	{23, 47, 12, 11},	/* change dir */
	{ 5, 36, 12, 11},	/* random */
	{ 5, 47, 12, 11},	/* repeat */
	{ 5, 16, 54, 10},	/* song title */
	{ 5,  5, 54, 10},	/* directory/list name */
	{ 5, 28, 54,  4}	/* progress bar */
};

struct coord btn_up[] = {
	{84,  5, 12, 11},	/* stop */
	{108, 5, 12, 11},	/* play */
	{96,  5, 12, 11},	/* pause */
	{96, 16, 12, 11},	/* back */
	{108,16, 12, 11},	/* next */
	{84, 16, 12, 11},	/* change dir */
	{66,  5, 12, 11},	/* random */
	{66, 16, 12, 11},	/* repeat */
	/* titles unchanged */
	{ 5, 16, 54, 10},	/* song title */
	{ 5,  5, 54, 10},	/* directory/list name */
	/* empty progress bar */
	{ 5, 68, 54,  4}	/* progress bar */
};

struct coord btn_down[] = {
	{84, 30, 12, 11},	/* stop */
	{108,30, 12, 11},	/* play */
	{96, 30, 12, 11},	/* pause */
	{96, 41, 12, 11},	/* back */
	{108,41, 12, 11},	/* next */
	{84, 41, 12, 11},	/* change dir */
	{66, 30, 12, 11},	/* random */
	{66, 41, 12, 11},	/* repeat */
	/* titles unchanged */
	{ 5, 16, 55, 10},	/* song title */
	{ 5,  5, 55, 10},	/* directory/list name */
	/* full progress bar */
	{ 5, 73, 54,  4}	/* progress bar */
};

struct coord btn_gray[] = {
	{84, 55, 12, 11},	/* stop */
	{108,55, 12, 11},	/* play */
	{96, 55, 12, 11},	/* pause */
	{96, 66, 12, 11},	/* back */
	{108,66, 12, 11},	/* next */
	{84, 66, 12, 11},	/* change dir */
	{66, 55, 12, 11},	/* random */
	{66, 66, 12, 11},	/* repeat */
	/* titles unchanged */
	{ 5, 16, 54, 10},	/* song title */
	{ 5,  5, 54, 10},	/* directory/list name */
	{ 5, 28, 54,  4}	/* progress bar */
};

